/*
 * WISA Beheerder wachtwoord dialoog.
 */
Ext.define('WISA.configpanels.Admin',{
  extend: 'WISA.BaseConfigPanel',
  fecurrentpwd : null,
  fenewpwd : null,
  fenewpwdc : null,
  savePwd: function () {
    if (!(this.fenewpwd.getValue()==this.fenewpwdc.getValue())) {
      WISA.ShowError('Foute ingave','Wachtwoord en verificatie wachtwoord stemmen niet overeen');
    } else {
      WISAServerConfig.ChangeAdminPassword(this.fecurrentpwd.getValue(),this.fenewpwd.getValue(),function (provider,response) {
        if (WISA.getResponseError(provider,response,'Fout bij wijzigen beheerder wachtwoord: ')) {
          if (!response.result) {
            WISA.ShowError('Server Fout','Kon het admin wachtwoord niet wijzigen');
          }
        }
      });
    }
  },
  constructor : function(options) {
    options.buttons = options.buttons || [];
    options.items = options.items || [];
    options.height = 100;
    this.fecurrentpwd = WISA.control('TextField',{
      fieldLabel: 'Huidig wachtwoord',
      name: 'currentpassword',
      inputType: 'password'
    });
    this.fenewpwd = WISA.control('TextField',{
      fieldLabel: 'Nieuw wachtwoord',
      name: 'fenewpwc',
      inputType: 'password'
    });
    this.fenewpwdc = WISA.control('TextField',{
      fieldLabel: 'Bevestig nieuw wachtwoord',
      name: 'fenewpwc',
      inputType: 'password'
    });
    options.items.push(this.fecurrentpwd,this.fenewpwd,this.fenewpwdc);
    options.buttons.push({text: 'Wachtwoord instellen', handler : this.savePwd, scope : this });
    options.title = 'Wachtwoord Beheerder';
    /* Inherited */
    this.callParent(arguments);
  }
});
Application.getConfigPanels().add('Admin','WISA.configpanels.Admin');

/*
 * Server configuratie
 */

Ext.define('WISA.configpanels.Server',{
  extend: 'WISA.BaseConfigPanel',
  constructor : function(options) {
    options.buttons = options.buttons || [];
    options.items = options.items || [];
    options.defaults = options.defaults || {};

    options.height = 100;
    options.defaults.width = 300;
    options.defaults.labelWidth = 150;
    options.title = 'Server configuratie';
    options.items.push(
     { xtype : 'textfield', name: 'WebsiteNaam', fieldLabel: 'Naam website' },
     { xtype : 'checkbox', name: 'Logging', fieldLabel: 'Logboek bijhouden' },
     { xtype : 'textfield', name: 'LogFile', fieldLabel: 'Locatie logboek', disabled: true },
     { xtype : 'textfield', name: 'TemplateDir', fieldLabel: 'Template map', disabled: true },
     { xtype : 'textfield', name: 'UploadDir', fieldLabel: 'Upload map', disabled: true },
     { xtype : 'textfield', name: 'DBConfig', fieldLabel: 'Bestand met databanken', disabled: true },
     { xtype : 'numberfield', name: 'Port', fieldLabel: 'FastCGI Poort', disabled: true }
    );
    /* Inherited */
    this.callParent(arguments);
  }
});
Application.getConfigPanels().add('Server','WISA.configpanels.Server');

/*
 * Configuratie scherm
 */

Ext.define('WISA.Forms.config',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false,
  ftabs : null,
  fadminpwd : null,
  fserver: null,
  fitems : [],
  /* Control references go here*/
  getServerConfig : function (provider,response) {
    var cfg = null;
    if (WISA.getResponseError(provider,response,'Laden server configuratie')) {
      cfg=response.result;
    }
    if (Ext.isObject(cfg)) {
      this.ftabs.items.each(function(a) {
        if (Ext.isFunction(a.setConfig)) {
          a.setConfig(cfg);
        }
      });
    }
  },
  savedServerConfig : function (provider,response) {
    if (WISA.getResponseError(provider,response,'Fout bij wijzigen server configuratie.')) {
      if (!response.result) {
        WISA.ShowError('Server Fout','Kon het admin wachtwoord niet wijzigen');
      }
    }
  },
  saveServerConfig : function () {
    var cfg = {};
    this.ftabs.items.each(function(a) {
      if (Ext.isFunction(a.getConfig)) {
          a.getConfig(cfg);
      }
    });
    WISAServerConfig.SetServerConfig(cfg,Ext.bind(this.savedServerConfig,this));
  },
  /* Build the actual form contents*/
  BuildForm: function (config) {
    this.fadminpwd = new WISA.configpanels.Admin({});
    this.fserver = new WISA.configpanels.Server({});
    Application.getConfigPanels().each(Ext.bind(function(a) {
      this.fitems.push(Ext.create(a,{}));
    },this));

    this.ftabs = new Ext.TabPanel({
      activeItem: 0,
      items : this.fitems
    });
    WISAServerConfig.GetServerConfig(Ext.bind(this.getServerConfig,this));
  /* Create controls here */
    return { layout: 'fit', items : [this.ftabs], tbar: [{text: 'bewaren', handler: this.saveServerConfig, scope: this}]};
  },

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Website configuratie";
  },

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
    }
  }
}); 
