Ext.define('WISA.Forms.klkalender',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false,
  /* Control references go here*/
  gkalender : null,
  dskalender : null,
  fusekleuren: true,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dskalender = WISA.dataset({
      ProviderName: 'KlasKalender',
      autoLoad: false,
      remoteGroup: false,
      groupField: 'AC_CODE'
    });
    /* Create controls here */
    this.gkalender = WISA.control('Grid',{
      title: 'Kalender',
      collapsible: true,
      collapsed: false,
      titleCollapse: true,
      autoHeight: true,
      cls: 'wisa-c-subtitle',
      padding: '5 25 10 25',
      store: this.dskalender,
      colModel : Ext.create('Ext.grid.header.Container',{
        defaults: {
          sortable: false,
          menuDisabled: false,
          groupable: false
        },
        items : [
          { dataIndex: 'KD_ID', header: 'ID', width: 40, hidden: true },
          { dataIndex: 'KD_VAN', header: 'Van', width: 40 , hidden: true },
          { dataIndex: 'KD_VANUUR', header: 'Uur', width: 40 , hidden: true },
          { dataIndex: 'KD_TOT', header: 'Tot', width: 40 , hidden: true },
          { dataIndex: 'KD_TOTUUR', header: 'Tot uur', width: 40 , hidden: true },
          { dataIndex: 'AC_CODE', header: 'Code', width: 70 },
          { dataIndex: 'PERIODE', header: 'Periode', width: 200},
          { dataIndex: 'MAAND', header: 'Maand', width: 200, sortable: true},
          { dataIndex: 'AC_OMSCHRIJVING', header: 'Omschrijving', width: 200},
          { dataIndex: 'AC_KLEUR', header: 'kleur', hidden: true }
        ]
      })
    });
    return { iconCls: 'icon-wisa-panel-klaskalender', cls: 'wisa-vakkenleerkrachten',  layout: 'fit', items : [ this.gkalender ] };
  },

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Klas kalender";
  },

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dskalender.load({params: {'LL_ID': Params.ID}});
    }
  }
});
