Ext.define('WISA.Forms.lbklas',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false,
  /* Control references go here*/
  fklas : null,
  dsloopbaan : null,
  dsklasgenoten : null,
  LoopbaanLoaded : function (store,records, options) {
    if (records.length==1) {
      this.fklas.getForm().loadRecord(records[0]);
    }
  },
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsloopbaan = WISA.dataset({
      ProviderName : 'LoopbaanGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.LoopbaanLoaded,this)}
    });
    this.dsklasgenoten = WISA.dataset({
      ProviderName : 'Klasgenoten',
      autoLoad: false,
    });
    this.fklas=WISA.control('FormPanel',{
      title: 'Huidige klas',
      autoHeight: true,
      collapsible: false,
      ollapsed: false,     
      titleCollapse: true,  
      padding: '5 25 10 0',
      cls: 'wisa-c-subtitle',
      labelWidth: 160,
      labelPad: 10,
      labelSeparator: '',
      labelAlign: 'right',
      defaultType: 'textfield',
      defaults: {
        readOnly: true,
        width: 300
      },
      items : [
        { name:  'LB_KLASNUMMER', fieldLabel: 'Klasnummer' },
        { name:  'KL_CODE', fieldLabel: 'Klascode' },
        { name:  'KL_OMSCHRIJVING', fieldLabel: 'Klas' },
        { name:  'AG_OMSCHRIJVING', fieldLabel: 'Studierichting' },
        { name:  'LB_LEERJAAR', fieldLabel: 'Leerjaar'},
        { name:  'LB_GRAAD', fieldLabel: 'Graad'}
      ]
    });
    this.gklasgenoten = WISA.control('Grid',{
      store: this.dsklasgenoten,
      title: 'Klasgenoten',
      autoHeight: true,
      collapsible: true,   
      collapsed: false,    
      titleCollapse: true, 
      padding: '5 25 10 25',
      cls: 'wisa-c-subtitle',
      columns: [
        {dataIndex: 'LL_ID', header: 'ID', hidden: true, sortable: true},
        {dataIndex: 'LB_KLASNUMMER', header: 'Nr.', sortable: true, width: 40},
        {dataIndex: 'LL_NAAM', header: 'Naam', sortable: true, width: 150},
        {dataIndex: 'LL_VOORNAAM', header: 'Voornaam', sortable: true, width: 150}
      ]
    })
    return { iconCls: 'icon-wisa-panel-klas', cls: 'wisa-klasgroep', items : [this.fklas, this.gklasgenoten] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Huidige klas";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
    }
    this.dsloopbaan.load({ params: {LL_ID: Params.ID}});
    this.dsklasgenoten.load({ params: {LL_ID: Params.ID}});
  }
}); 
