Ext.define('WISA.Forms.llafwezigheden',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false, 
  autoScroll: true,
  /* Control references go here*/
  gafwezigheden : null,
  dsafwezigheden : null,
  pafwezigheden : null,
  fusekleuren: false,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsafwezigheden = WISA.dataset({
      ProviderName: 'Afwezigheden',
      autoLoad: false,
      remoteGroup: false,
      groupField: 'AC_CODE'
    });
    this.pafwezigheden = WISA.control('FormPanel',{
      title : 'Jaaroverzicht',
      layout: 'fit',
      collapsible: true,
      collapsed: true,
      titleCollapse: true,
      cls: 'wisa-c-subtitle',
      padding: '5 25 10 25'
    });
    /* Create controls here */
    var groupingFeature = Ext.create('Ext.grid.feature.Grouping', {
       hideGroupedColumn: false,
       enableNoGroups: true,
       showGroupName: true,
       groupHeaderTpl: '{name} : {[values.rows[0].afwezigomschrijving]} ({rows.length}  {[values.rows.length > 1 ? "meldingen" : "melding"]})'
    });
    this.gafwezigheden = WISA.control('Grid',{
      title: 'Afwezigheden',
      collapsible: true,
      collapsed: true,
      titleCollapse: true,
      cls: 'wisa-c-subtitle',
      padding: '5 25 10 25',
      autoHeight: true,
      store: this.dsafwezigheden,
      features: [groupingFeature],
      columns : Ext.create('Ext.grid.header.Container',{
        defaults: {
          sortable: true,
          menuDisabled: false,
          groupable: false
        },
        items : [
          /*
           * { dataIndex: 'AF_ID', header: 'ID', width: 40, hidden: true },
           * { dataIndex: 'AF_VAN', header: 'Van', width: 40 , hidden: true },
           * { dataIndex: 'AF_VANUUR', header: 'Uur', width: 40 , hidden: true },
           * { dataIndex: 'AF_TOT', header: 'Tot', width: 40 , hidden: true },
           * { dataIndex: 'AF_TOTUUR', header: 'Tot uur', width: 40 , hidden: true },
           * { dataIndex: 'MAAND', header: 'Maand', width: 150, sortable: true, groupable: true},
           * { dataIndex: 'AC_KLEUR', header: 'kleur', hidden: true },
           * { dataIndex: 'AF_REFERENTIE', header: 'Referentie', hidden: true },
           */
          { dataIndex: 'AC_CODE', header: 'Code', width: 50 /*, groupName: 'Soort melding'*/ },
          { dataIndex: 'AC_OMSCHRIJVING', header: 'Omschrijving', width: 300, groupable: true, id: 'afwezigomschrijving'},
          { dataIndex: 'PERIODE', header: 'Periode', width: 190},
          { dataIndex: 'AF_COMMENTAAR', header: 'Commentaar' , width: 200},
          { dataIndex: 'AF_BRIEFJEVAN', header: 'Briefje van' }
        ]
      }),
      tbar: [{
        pressed: false,
        enableToggle:true,
        text:'Kleuren',
        tooltip: {title:'Kleuren',text:'Gebruik kleuren voor verschillende soorten afwezigheid'},
        iconCls: 'icon-wisa-btn-kleuren',
        scope:this,
        toggleHandler: function(btn, pressed){
            this.fusekleuren = ! this.fusekleuren;
            this.gafwezigheden.getView().refresh();
        }
      },{
        xtype: 'tbseparator'
      },{
        text:'Groepen openklappen',
        tooltip: {title:'Groepen openklappen',text:'Alle groepen openklappen'},
        iconCls: 'icon-wisa-btn-grexpand',
        scope:this,
        handler: function(btn, pressed){
            this.gafwezigheden.getView().expandAllGroups();
        }
      },{
        xtype: 'tbseparator'
      },{
        text:'Groepen dichtklappen',
        tooltip: {title:'Groepen dichtklappen',text:'Alle groepen dichtklappen'},
        iconCls: 'icon-wisa-btn-grcollapse',
        scope:this,
        handler: function(btn, pressed){
            this.gafwezigheden.getView().collapseAllGroups();
        }
      }]
    });

    this.gafwezigheden.getView().getRowClass = Ext.bind(function(record, index){
     if (this.fusekleuren) {
       return 'afwezigkleur'+record.data.AC_ID;
     }
    },this);
    return { layout: {type: 'vbox', align: 'stretch' }, cls: 'wisa-afwezigheden', iconCls: 'icon-wisa-panel-afwezigheden', items : [this.pafwezigheden, this.gafwezigheden ] };
  }, 
  LoadJaarOverzicht : function (Provider,Response) {
    if (WISA.CheckError(Provider,Response,'Fout bij het ophalen van het jaaroverzicht')) {
      this.pafwezigheden.removeAll();
      this.pafwezigheden.add([{xtype: 'panel', title:'', border: false, html: Response.result}]);
      this.pafwezigheden.doLayout();
    }
  } ,
 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Afwezigheden";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dsafwezigheden.load({params: {'LL_ID': Params.ID}});
      WebOudersAPI.GetAfwezighedenOverzicht(Params.ID,Ext.bind(this.LoadJaarOverzicht,this));
    }
  }
}); 
