/* Moet naar wisa.js */
Ext.define('WISA.Forms.llinterventie',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsinterventies : null,
  ginterventies: null,
  pinterventie: null,
  tinterventie: null,
  ggrouping : null,
  /* Build the actual form contents*/
  interventiesLoaded: function (store,records, options) {
    if (records.length) {
      this.ginterventies.getSelectionModel().select(0);
    }
  },
  BuildForm: function () {
    this.dsinterventies = WISA.dataset({
        ProviderName: 'Interventies',
        autoLoad: false,
        remoteGroup: false,
        groupField: 'LI_TYPE',
        listeners: {load: Ext.bind(this.interventiesLoaded,this) }
    });
    this.pinterventie = WISA.control('Panel',{
      title: 'Details interventie',
      height: 250,
      region: 'south',
      split: true,
      collapsible: false,
      border: true,
      cls: 'wisa-c-subtitle2',
      padding: '5 25 5 0',
      autoScroll: true
    });
    this.ggrouping = Ext.create('Ext.grid.feature.Grouping', {
         hideGroupedHeader: false,
         enableNoGroups: true,
         groupHeaderTpl: '{name} ({[values.rows.length]} interventie{[values.rows.length > 1 ? "s" : ""]})'
    });
    this.tinterventie = new Ext.Template('<div class="wisa-txt-ag">'
	 +'<div class="wisa-det"><div class="wisa-det-label">Type:</div><div class="wisa-det-txt">{LI_TYPE}</div><div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Datum - uur:</div><div class="wisa-det-txt">{LI_DATUM:date("Y-m-d")}&nbsp;&nbsp;{LI_TIJD:date("H:i")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Omschrijving:</div><div class="wisa-det-txt">{LI_OMSCHRIJVING}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Motief:</div><div class="wisa-det-txt">{LI_MOTIEF:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Betrokken personen:</div><div class="wisa-det-txt">{LI_BETROKKENPERSOON:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Derden:</div><div class="wisa-det-txt">{LI_DERDEN:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Opmerking:</div><div class="wisa-det-txt">{LI_OPMERKING}</div></div></div>'
    ,{
      compiled: true
    });
    this.ginterventies = WISA.control('Grid',{
      title: 'Overzicht alle interventies',
      collapsible: true,
      collapsed: false,
      titleCollapse: true,
      cls: 'wisa-c-subtitle',
      padding: '5 25 10 25',	  
      region: 'center',
      store: this.dsinterventies,
      features: [this.ggrouping],
      columns: Ext.create('Ext.grid.header.Container',{
        defaults:{
          groupable: false,
          sortable: false
        },
        items: [
          { dataIndex: 'LI_DATUM', header: 'Datum', width: 75, sortable: true, renderer: function(d, p, record) {
              return Ext.Date.format(d,'Y-m-d');
            }
          },
          { dataIndex: 'LI_TYPE', header: 'Type', width: 120, sortable: true, groupable: true },
          { dataIndex: 'LI_OMSCHRIJVING', header: 'Omschrijving', width: 200, sortable: true},
          { dataIndex: 'LI_OPMERKING', header: 'Opmerking', width: 300 },
          { dataIndex: 'LI_BETROKKENPERSOON', header: 'Betrokken persoon', sortable: true, width: 120 },
          { dataIndex: 'LI_DERDEN', header: 'Derden', width: 120,  hidden: true },
          { dataIndex: 'LI_TYPECODE', header: 'Type code', width: 120, sortable: true, hidden: true },
          { dataIndex: 'LI_MOTIEFCODE', header: 'Motief code', width: 120, sortable: true, hidden: true },
          { dataIndex: 'LI_BETROKKENPERSOONTYPE', header: 'Type betrokken persoon', width: 120, hidden: true }
          /*
           * { dataIndex: 'LI_TIJD', header: 'tijd', width: 50, renderer:  function(time, p, record) {
           *    return time.format('G:i');
           * { dataIndex: 'LI_MOTIEF', header: 'Motief', sortable: true, width: 120 },
           * { dataIndex: 'LI_MAAND', header: 'Maand', width: 120, sortable: true, groupable: true },
           * { dataIndex: 'LI_PLAATS', header: 'Plaats', sortable: true, width: 120 },
           */
        ]
      }),
      selModel: Ext.create('Ext.selection.RowModel',{
        mode: 'SINGLE',
        listeners: {
          'select' : Ext.bind(function(sm, record, index){
              this.tinterventie.overwrite(this.pinterventie.body, record.data);
            },this)
        }
      }),
      tbar: [{
        text:'Groepen openklappen',
        tooltip: {title:'Groepen openklappen',text:'Alle groepen openklappen'},
        iconCls: 'icon-wisa-btn-grexpand',
        scope:this,
        handler: function(btn, pressed){
            this.ggrouping.expandAll();
        }
      },{
        xtype: 'tbseparator'
      },{
        text:'Groepen dichtklappen',
        tooltip: {title:'Groepen dichtklappen',text:'Alle groepen dichtklappen'},
        iconCls: 'icon-wisa-btn-grcollapse',
        scope:this,
        handler: function(btn, pressed){
            this.ggrouping.collapseAll();
        }
      }]
    });
    return { layout: 'border', iconCls: 'icon-wisa-panel-leerlinginterventie', cls: 'wisa-leerlinginterventie', items : [this.ginterventies, this.pinterventie ] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Interventies";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dsinterventies.load({params: {LL_ID: Params.ID }})
    }
  }
}); 
