Ext.define('WISA.Forms.llpersoonfiche',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  /* Control references go here*/
  border: false,
  ffiche: null,
  fouders: null,
  fgezin: null,
  padres: null,
  dspersonalia: null,
  dsadressen: null,
  dsbroerzus: null,
  pbroerzus: null,
  gbroerzus : null,

  /* Build the actual form contents*/
  BuildEdit: function (alabel,afield, avalue) {
     return {fieldLabel: alabel, name: afield, value: avalue };
  },
  DefaultFormConfig: function (atitle,acls) {
    return {
      cls:'wisa-persoonsgegevens-'+acls,
      title: atitle,
      collapsible: true,
      titleCollapse: true,	  
      padding: '5 0 10 0',
      defaultType: 'textfield',
      defaults: {
        readOnly: true,
        labelWidth: 160,
        labelPad: 10,
        labelSeparator: ':',
        labelAlign: 'right',
        width: 250
      }
    }
  },
  PersonaliaLoaded: function (store,records, options) {
    if (records.length==1) {
      this.ffiche.getForm().loadRecord(records[0]);
      if (!Ext.isEmpty(this.fouders)) {
        this.fouders.getForm().loadRecord(records[0]);
      }
    }
  },
  AdressenLoaded: function (store,records, options) {
    var fa = []
    for (var i=0; i<records.length; i++) {
      var aform = null;
      var r = records[i];
      var cfg = this.DefaultFormConfig(r.data.LA_TYPEADRES,'adres');
      cfg=Ext.apply(cfg,{
        cls: 'wisa-c-subtitle2',
        collapsed: (i>0),
        items: [
          this.BuildEdit('Naam','LA_NAAM'),
          this.BuildEdit('Aanspreking','LA_AANSPREKING'),
          this.BuildEdit('Straat','LA_STRAAT'),
          this.BuildEdit('Nr.','LA_STRAATNR'),
          this.BuildEdit('Bus','LA_STRAATBUS'),
          this.BuildEdit('Postcode','GM_POSTNUMMER'),
          this.BuildEdit('Gemeente','GM_DEELGEMEENTE'),
          this.BuildEdit('Telefoon','LA_TELEFOON')
        ]
      });
      aform = WISA.control('FormPanel',cfg);

      aform.getForm().loadRecord(r);
      fa.push(aform);
    }
    this.cadressen.add(fa);
  },
  createPersonaliaConfig : function () {
    var cfg = this.DefaultFormConfig('Personalia','personalia');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: false,
      items:[
        this.BuildEdit('Voornaam','LL_VOORNAAM'),
        this.BuildEdit('Naam','LL_NAAM'),
        this.BuildEdit('Andere voornamen','LL_VOORNAAM2'),
        this.BuildEdit('Roepnaam','LL_ROEPNAAM'),
        this.BuildEdit('Geslacht','LL_GESLACHT'),
        this.BuildEdit('Geboortedatum','LL_GEBOORTEDATUM'),
        this.BuildEdit('Geboortegemeente','LL_GEBOORTEGEMEENTE'),
        this.BuildEdit('Nationaliteit','LL_NATIONALITEIT'),
        this.BuildEdit('Moedertaal','LL_MOEDERTAAL'),
        this.BuildEdit('Nr. identiteitskaart','LL_IDENTITEITSKAARTNR'),
        this.BuildEdit('Rijksregisternummer','LL_RIJKSREGISTERNR'),
        this.BuildEdit('Onderwijsnummer','LL_BISNUMMER'),
        this.BuildEdit('Bankrekening','LL_BANKREKENING'),
        this.BuildEdit('E-mail','LL_EMAIL'),
        this.BuildEdit('GSM','LL_GSM'),
        this.BuildEdit('Noodtelefoon','LL_NOODTELEFOON'),
        this.BuildEdit('Noodtelefoon bij','LL_NOODTELEFOONBIJ')
       ]
    });
    return cfg;
  },
  createOuderConfig : function () {
    var cfg = this.DefaultFormConfig('Ouders','ouders');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: true,
      items: [
        this.BuildEdit('Naam vader','LL_VADERNAAM'),
        this.BuildEdit('Voornaam vader','LL_VADERVOORNAAM'),
        this.BuildEdit('E-mail vader','LL_VADEREMAIL'),
        this.BuildEdit('Burgerlijke staat vader','LL_VADERBURGERLIJKESTAAT'),
        this.BuildEdit('GSM vader','LL_VADERGSM'),
        this.BuildEdit('Naam moeder','LL_MOEDERNAAM'),
        this.BuildEdit('Voornaam moeder','LL_MOEDERVOORNAAM'),
        this.BuildEdit('E-mail moeder','LL_MOEDEREMAIL'),
        this.BuildEdit('Burgerlijke staat moeder','LL_MOEDERBURGERLIJKESTAAT'),
        this.BuildEdit('GSM vader','LL_MOEDERGSM')
      ]
    });
    return cfg;
  },
  BroerzusLoaded: function (store,records, options) {
  },
  BuildForm: function () {
    this.dspersonalia = WISA.dataset({
      ProviderName: 'PersoonsGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.PersonaliaLoaded,this)}
    });
    this.dsadressen = WISA.dataset({
      ProviderName: 'AdresGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.AdressenLoaded,this)}
    });
    this.dsbroerzus = WISA.dataset({
      ProviderName: 'BroerzusGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.BroerzusLoaded,this)}
    });
    var ctrls = [];
    var cfg = this.createPersonaliaConfig();
    this.ffiche = WISA.control('FormPanel',cfg);
    ctrls.push(this.ffiche);
    if (Application.getSessionConfig().ToonGezinData) {
      cfg = this.createOuderConfig();
      this.fouders = WISA.control('FormPanel',cfg);
      ctrls.push(this.fouders);
    }
    cfg = this.DefaultFormConfig('Adres','adressen');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: true
    });
    // Container tussen steken.
    // Nodig om communicatie tussen 2 accordions (form en panel) te verbreken.
    this.cadressen = Ext.widget('container',  {layout: 'accordion'});
    this.padres = WISA.control('Panel',{
      title: 'Adressen',
      collapsible: true,
      collapsed: true,
      titleCollapse: true,
      layout: 'fit',
      items : [this.cadressen ]
    });
    ctrls.push(this.padres);
    if (Application.getSessionConfig().ToonGezinData) {
      this.gbroerzus = WISA.control('Grid',{
        title: 'Broer/zus',
        collapsible: true,
        collapsed: true,
        titleCollapse: true,
        enableHdMenu: false,
        padding: '0 25 0 25',
        store: this.dsbroerzus,
        columns: [
          { xtype:'actioncolumn', width:25,
            items: [{
                icon: 'pics/icons/person116.png',  // Use a URL in the icon config
                tooltip: 'Tonen',
                handler: function(grid, rowIndex, colIndex) {
                    var rec = grid.getStore().getAt(rowIndex);
                    var llid = rec.get('LL_ID');
                   Application.Ouders.ExpandLeerling(llid);
                   Application.ShowForm({form: 'llpersoonfiche', Params: {ID: llid}});
                }
            }]
          },
          {header: 'ID', dataIndex: 'LL_ID', hidden: true },
          {header: 'Voornaam', dataIndex: 'LL_VOORNAAM', align: 'center', cellActions:[{
                                                   iconCls:'llpersoonfiche'
                                                  ,qtip:'Details bekijken'
                                                  ,hide:true
                                                  ,hideMode:'display'
                                           }]},
          {header: 'Naam', dataIndex: 'LL_NAAM' }
        ],
      });
      ctrls.push(this.gbroerzus);
    }
    return {
      autoScroll: true,
      iconCls: 'icon-wisa-panel-persoonsgegevens',
      cls: 'wisa-c-subtitle',
//      layout: {type : 'vbox', align: 'stretch' }, // accordion', // DEVart : add layout accordeon
      layout: 'accordion', // DEVart : add layout accordeon
      items: ctrls
    };
  },

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Fiche";
  }, 
  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dspersonalia.load({params: {ID: Params.ID}});
      this.dsadressen.load({params: {ID: Params.ID}});
      this.dsbroerzus.load({params: {ID: Params.ID,ID2: Params.ID}});
    }
  }
});
