Ext.define('WISA.Forms.llrapport',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsrapporten : null,
  grapporten : null,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsrapporten = WISA.dataset({
      ProviderName: 'rapporten',
      autoLoad: false
    });
    this.grapporten = WISA.control('Grid',{
      store: this.dsrapporten,
      title: 'Overzicht rapporten dit schooljaar',
      collapsible: true,
      collapsed: false,
      titleCollapse: true,
      autoHeight: true,
      cls: 'wisa-c-subtitle',
      padding: '5 25 10 25',  
      columns: [
        { dataIndex: 'MR_ID', header: 'ID', hidden: true},
        { dataIndex: 'MR_CODE', header: 'Periode', width: 100},
        { xtype: 'datecolumn', dataIndex: 'D_LAATSTEWIJZIGING', header: 'Datum', width: 100, format: 'd/m/Y'},
        { dataIndex: 'MR_OMSCHRIJVING', header: 'Omschrijving', width: 300, renderer:  function(oms, p, record) {
                       if (record.data.D_ID) {
                         return '<a href="bin/filemanager.cgi/doc/get?D_ID='+record.data.D_ID+'">'+oms+'</a>';
                       } else {
                         return oms;
                       }
                    }
        }
      ]
    });
    /* Create controls here */
    return { layout: 'fit', items: [this.grapporten], iconCls: 'icon-wisa-panel-rapporten', cls: 'wisa-rapporten' };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Rapporten";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dsrapporten.load({params:{LL_ID : Params.ID}});
    }
  }
}); 
