Ext.define('WISA.Forms.llrekening',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsrekeningen: null,
  /* Build the actual form contents*/
  getFactTitle : function (r) {
    var s = 'Rekening '+r.CD_DOCUMENT+' van ';
    s += Ext.Date.format(r.CD_DATE,'Y-m-d') + ' - '+ r.CD_SUMTOTAL + ' euro: ';
    s += r.ISBETAALD == 0 ?  '<span class="wisa-txt-g">betaald</span>' : '<span class="wisa-txt-r">onbetaald</span>';
    return s
  },
  LoadRekeningen: function  (store,records, options) {
    var p = null;
    this.removeAll();
    if (records.length==0) {
      p = WISA.control('Panel',{
        collapsible: false,
        padding: '5 5 5 5',
        html:'<span class="wisa-e-txt">Geen rekeningen</span>'
      });
      this.add(p);
    } else {
       for (var i = 0; i<records.length; i++) {
         var r = records[i].data;
         p = WISA.control('FormPanel',{
           title: this.getFactTitle(r),
           titleCollapse: true,
           collapsible: true,
           collapsed: true,
           autoHeight: true,
           //height: 600,
           cls: 'wisa-c-subtitle',
           padding: '5 0 25 0',
           defaults : {
             readOnly: true,
             labelWidth: 160,
             labelPad: 10,
             labelSeparator: ':',
             labelAlign: 'right'
           },
           items : [
             {xtype: 'textfield', fieldLabel: 'Bedrag (euro)', value: r.CD_SUMTOTAL},
             {xtype: 'datefield', fieldLabel: 'Te betalen tegen', value: (r.CD_DUEDATE) ? Ext.Date.format(r.CD_DUEDATE,'Y-m-d'): '' },
             {xtype: 'checkbox', fieldLabel: 'Domiciliering', value: r.CD_DOMICIL == '+' },
             {xtype: 'checkbox', fieldLabel: 'Gedeelde betaling', value: r.DB_SHAREPAYMENT == '+'},
             {xtype: 'grid', 
               collapsible: true, 
               border: false, 
               collapsed: true,
               titleCollapse: true,
//               autoHeight: true,
               height: 200,
               padding: '0 25 25 25',
               cls: 'wisa-c-subtitle2',
               title: 'Detail rekening',
               store: WISA.dataset({
                 ProviderName: 'Artikels',
                 autoLoad: false
               }),
               columns: [
                 {dataIndex: 'CDD_ID,', header: 'ID', width: 80, hidden: true},
                 {dataIndex: 'AR_CODE', header: 'Code', width: 100 },
                 {dataIndex: 'AR_DESCRIPTION', header: 'Artikel', width: 300 },
                 {dataIndex: 'CDD_PRICE', header: 'Eenheidsprijs', width: 100, align: 'center' },
                 {dataIndex: 'CDD_QTY', header: 'Aantal', width: 80, align: 'center' },
                 {dataIndex: 'CDD_AMOUNT', header: 'Totaal (euro)', width: 100, align: 'center' }
               ],
               listeners: {
                 expand: function (d) {
                   return Ext.bind(function (g) {
                     if (g.getStore().getCount() == 0 ) {
                       g.getStore().load({params: {CD_ID: d.CD_ID}});
                     }
                   },this)
                 }(r)
               }
             } // grid
           ] // items
         });
         this.add(p);
       } // For
    } // else
    this.doLayout();
  },
  BuildForm: function () {
    this.dsrekeningen = WISA.dataset({
      ProviderName : 'Facturen',
      autoLoad: false,
      listeners: {load: Ext.bind(this.LoadRekeningen,this)}
    });
    return {
       iconCls: 'icon-wisa-panel-facturen', 
       autoHeight: true,
//       layout: {type: 'vbox', align: 'stretch'},
       layout: {type: 'accordion'},
       items: []
    };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Rekeningen";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dsrekeningen.load({params: {LL_ID: Params.ID }})
    }
  }
}); 
