Ext.define('WISA.Forms.llzorgfiche',{
  extend: 'WISA.Form',
  /* Change some config properties here */
  border: false,
  dsmedisch: null,
  dszorgfiche: null,
  ficheloaded: false,
  zorgloaded: false,
  gzorg : null,
  fccount : 0,
  AddZorg : function(datum,type,opmerking) {
    if (opmerking.trim() != '') {
      this.fccount--;
      var d = {
        LZ_TYPECODE : 'MF',
        LZ_TYPE : type,
        LZ_GEBIED : 1,
        LZ_OPMERKING : opmerking,
        LZ_DATUM : datum,
        LZ_ID : this.fccount
      };
      this.dszorgfiche.add(this.dszorgfiche.createModel(d));
    }
  },
  ConvertFiche: function () {
    if (this.dsmedisch.getCount() != 0) {
      var d = this.dsmedisch.getAt(0).data;
      this.AddZorg(d.MF_ZICHTSINDS,'Zicht',d.MF_ZICHT);
      this.AddZorg(d.MF_SPRAAKSINDS,'Spraak',d.MF_SPRAAK);
      this.AddZorg(d.MF_GEHOORSINDS,'Gehoor',d.MF_GEHOOR);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK1);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK2);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK3);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK4);
      this.AddZorg(null,'Andere',d.MF_ANDERE);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD1);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD2);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD3);
      this.AddZorg(null,'Andere',d.MF_VRIJPARAM1);
      this.AddZorg(null,'Andere',d.MF_VRIJPARAM2);
      this.AddZorg(null,'SIS Kaart',d.MF_SISKAART);
      this.AddZorg(null,'Ziekenfondsnummer',d.MF_ZIEKENFONDSNUMMER);
    }
  },
  /* Control references go here*/
  MedischLoaded : function (store,records, options) {
    this.ficheloaded=true;
    if (this.zorgloaded) {
      this.ConvertFiche();
    }
    return true
  },
  ZorgLoaded : function (store,records, options) {
    this.zorgloaded=true;
    if (this.ficheloaded) {
      this.ConvertFiche();
    }
    return true
  },
  FormatDate : function(date, metadata, record, rowindex, colindex,store,view) {
      if (!date) {
          return '';
      }
      var d = Ext.Date.clearTime(new Date());
      var notime = Ext.Date.clearTime(date,true).getTime();
      var s = '';
      if (notime == d.getTime()) {
         s = 'Vandaag';
      } else {
         s = Ext.Date.format(date,'Y-m-d');
      }
      return s;
  },
  /* Build the actual form contents*/
  BuildForm: function () {
  /* Create controls here */
    this.dsmedisch = WISA.dataset({
      ProviderName: 'MedischeGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.MedischLoaded,this)}
    });
    this.dszorgfiche = WISA.dataset({
      ProviderName: 'ZorgGegevens',
      autoLoad: false,
      listeners: {load: Ext.bind(this.ZorgLoaded,this)}
    });
    this.gzorg = WISA.control('Grid',{
      store: this.dszorgfiche,
      height: 300,
//      autoHeight: true,
//      collapsible: true,
//      collapsed: false	,
//      titleCollapse: true,
      padding: '0 25 0 25',
      title: 'Zorgfiche & medische gegevens',
      columns : [
        {dataIndex: 'LZ_GEBIED', header: 'Gebied', width: 100, sortable: true, hidden: true },
        {dataIndex: 'LZ_TYPECODE', header: 'Type', width: 100, sortable: true },
        {dataIndex: 'LZ_TYPE', header: 'Type', width: 200, sortable: true },
        {dataIndex: 'LZ_OPMERKING', header: 'Omschrijving', width: 300 },
        {dataIndex: 'LZ_DATUM', header: 'Datum', width: 164, sortable: true, renderer: this.FormatDate },
        {dataIndex: 'LZ_ID', header: 'ID', width: 30, hidden: true}
      ]
    });
    return { cls: 'wisa-c-subtitle', iconCls: 'icon-wisa-panel-zorgfiche', items : [this.gzorg], layout: 'fit'	};
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Zorgfiche ";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      this.callParent(arguments);
      this.dsmedisch.load({params: {ID: Params.ID}});
      this.dszorgfiche.load({params: {ID: Params.ID}});
    }
  }
});
