Ext.define('WISA.Forms.login',{
  extend: 'WISA.Dialog',
  /* Control references */ 
  blogin : null,
  eusername : null,
  epassword : null,
  plock : null,
  fform : null,
  /* Callbacks */
  loginbuttonclick : function (sender) {
    Application.DoLogin({user: this.eusername.getValue(), password: this.epassword.getValue() });
  },
  focususer : function () {
    this.eusername.focus();
  },
  /* Build the actual form */
  BuildForm: function (me) {
    this.eusername = WISA.control('TextField',{
      name:"user",
      fieldLabel:"Gebruikersnaam",
      inputType:"text"
    });
    this.epassword = WISA.control('TextField',{
      name:"pass",
      fieldLabel:"Wachtwoord",
      inputType:"password"
    });
    this.blogin = WISA.control('Button',{
       text:"Aanmelden",
       handler : this.loginbuttonclick,
       cls: 'wisa-aanmelden',
       scope : this
    });
    this.fform = WISA.control('Panel',{
      width: 350,
      labelWidth:150,
      border:false,
      //xtype: "form",
      buttonAlign: "right",
      bodyStyle: "padding: 10px 15px",
      defaultType: "textfield",
      defaults: {width: 150},
      items: [this.eusername,this.epassword],
      buttons:[this.blogin],
      keys: {key: Ext.EventObject.ENTER,  
             handler: function(){  
               this.blogin.focus(); 
             }, 
             scope: this
      }
    });
    this.plock = WISA.control('Panel',{
      border:false,
      html:"<img src='pics/login.png' width=114 height=128/>",
      width:114,
      height:128
    });
    return {
      id   : 'wisa-login', 
      statefull : false , 
      title: "Aanmelden",
      width: 500,
      height: 200,
      plain: true,
      layout: "hbox",
      headerCssClass: 'wisa-login',
      bodyCssClass: 'wisa-login',
      defaultButton: this.eusername,
      bodyCfg :{
        cls: 'x-panel-body'
      },
      layoutConfig: {
        align : "middle",
        pack: "center"
      },
      closable: false,
      listeners: {
        'show' : { fn: Ext.bind(this.focususer,this) },
        'render' : { fn : function() { 
                Ext.create('Ext.Panel',{
                    id : 'wisa-login-logo',
                    border : false,
                    renderTo : Ext.getBody()
                });
            } 
        }
      },
      items: [ this.fform, this.plock ] 
    };
  }, /* Buildform*/
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      this.callParent(arguments);
      if ((Params.user) && (Params.password)) {
        this.eusername.setValue(Params.user);
        this.epassword.setValue(Params.password);
        this.loginbuttonclick();
      }
    }
  }
});

