Ext.define('WISA.Forms.changepassword',{
  extend: 'WISA.Dialog',
  eold : null,
  enew : null,
  enewcheck : null,
  bchange : null,
  bcancel : null,
  PasswordChanged : function (Provider,Response) {
    if ( Ext.isEmpty(Response) || (! Ext.isEmpty(Response.error))) {
      WISA.AjaxError('Fout bij wijzigen wachtwoord: '+Response.error.message);
    } else {
      this.close();
    }
  },
  ChangeClick : function () {
    if (this.enew.getValue() != this.enewcheck.getValue()) {
      WISA.ShowError('Wachtwoord wijziging mislukt','De nieuwe wachtwoorden zijn niet hetzelfde. Probeer opnieuw.');
    } else {
      WisaUserAPI.ChangePassword(this.eold.getValue(),this.enew.getValue(), Ext.bind(this.PasswordChanged,this));
    }
  },
  CancelClick : function () {
    this.close();
  },
  BuildForm: function (me) {
    this.eold = WISA.control('TextField',{
      name:"oldpw",
      fieldLabel:"Huidig wachtwoord",
      inputType:"password"
    });
    this.enew = WISA.control('TextField',{
      name:"newpd",
      fieldLabel:"Nieuw wachtwoord",
      inputType:"password"
    });
    this.enewcheck = WISA.control('TextField',{
      name:"newpdcheck",
      fieldLabel:"Herhaal nieuw wachtwoord",
      inputType:"password"
    });
    this.bchange = WISA.control('Button',{
       text:"Wijzigen",
       handler : this.ChangeClick,
       cls: 'wisa-wijzigwachtwoord',
       scope : this
    });
    this.bcancel = WISA.control('Button',{
       text:"Annuleren",
       handler : this.CancelClick,
       cls: 'wisa-wijzigwachtwoord',
       scope : this
    });
    this.fform = WISA.control('FormPanel',{
      border:false,
      defaultType: "textfield",
      items: [this.eold,this.enew,this.enewcheck],
      buttons:[this.bchange, this.bcancel]
    });
    return {
      title: "Wachtwoord wijzigen",
      width: 500,
      plain: true,
      layout: "hbox",
      bodyCfg :{
        cls: 'x-panel-body'
      },
      layoutConfig: {
        align : "middle",
        pack: "center"
      },
      closable: true,
      items: [ this.fform ]
    };
  }
});

Ext.define('WISA.Forms.myprofile',{
  extend: 'WISA.Form',
  fform : null,
  dsuser : null,
  bchangepwd : null,
  LoadData: function (store,records,options) {
    if (records.length==1) {
      this.fform.getForm().loadRecord(records[0]);
      this.bchangepwd.setDisabled(records[0].data.U_KANVERANDERPASW!='+');
    }
  },
  ChangePassword : function () {
    Application.ShowDialog({form: 'changepassword'});
  } ,
  BuildForm: function () {
    this.dsuser = WISA.dataset({
      ProviderName: 'UserFiche',
      listeners: {load: {fn: this.LoadData, scope : this}},
      autoLoad: true
    });
    this.bchangepwd = WISA.control('Button',{
      id  : 'wisa-wijzigwachtwoord', // DEVart: added id  
      text: 'Wachtwoord wijzigen',
      enabled: false,
      handler: this.ChangePassword
    });
    this.fform = WISA.control('FormPanel',{
      //title : 'Gebruikersgegevens', DEvart removed title
      cls: 'wisa-c-subtitle',
      //collapsible: true, DEvart removed option
      //titleCollapse: true, DEvart removed option
      border : false, // DEVart removed border
      labelWidth: 160,
      labelPad: 10,
      labelSeparator: ':',
      labelAlign: 'right',
      padding: 10,	// DEVart changed padding from 5 0 10 0 to 10
      buttonAlign: "left",	  
      defaults: {width: 300},
      items : [
       {name: 'U_ID', /* disabled: true, */ fieldLabel: 'Gebruikersnummer', xtype: 'textfield'},
       {name: 'U_NAAM', /* disabled: true, */ fieldLabel: 'Gebruikersnaam', xtype: 'textfield'},
       {name: 'U_NAAMVOLLEDIG',  /* disabled: true, */  fieldLabel: 'Volledige naam', xtype: 'textfield'},
       {name: 'U_LAATSTELOGIN', disabled: true, fieldLabel: 'Laatst aangemeld op', xtype: 'datefield', format : 'd/m/Y', width: 150 },
       {name: 'U_LAATSTELOGOUT', disabled: true, fieldLabel: 'Laatst afgemeld op', xtype: 'datefield', format : 'd/m/Y', width: 150 },
       {name: 'U_VRIJVELD1',  /* disabled: true, */ fieldLabel: 'Vrij veld 1', xtype: 'textfield' },
       {name: 'U_VRIJVELD2',  /* disabled: true, */ fieldLabel: 'Vrij veld 2', xtype: 'textfield' }
      ],
      buttons: [ this.bchangepwd ]
    });
    return { layout: {type: 'vbox', align: 'stretch', pack: 'top' }, border : false,  items : [ this.fform] } // DEVart set border to false
  },
  getFormTitle: function () {
    return "Mijn gebruikersgegevens";
  },
  ApplyParams : function (Params) {
  //
  }
});
