WISA.Forms.lbklas = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false,
  /* Control references go here*/
  fklas : null,
  dsloopbaan : null,
  dsklasgenoten : null,
  LoopbaanLoaded : function (store,records, options) {
    if (records.length==1) {
      this.fklas.getForm().loadRecord(records[0]);
    }
  },
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsloopbaan = new WISA.ClientDataset({
      ProviderName : 'LoopbaanGegevens',
      autoLoad: false,
      listeners: {load: this.LoopbaanLoaded.createDelegate(this)}
    });
    this.dsklasgenoten = new WISA.ClientDataset({
      ProviderName : 'Klasgenoten',
      autoLoad: false,
      listeners: {load: this.LoopbaanLoaded.createDelegate(this)}
    });
    this.fklas=new Ext.FormPanel({
      title: 'Huidige klas',
	  autoHeight: true,
      collapsible: true,
      collapsed: false,
      titleCollapse: true,
	  padding: '5 25 10 0',
	  cls: 'wisa-c-subtitle',	  
	  labelWidth: 160,
      labelPad: 10,
      labelSeparator: ':',
	  labelAlign: 'right',
      defaultType: 'textfield',
      defaults: {
        readOnly: true,
        width: 300
      },
      items : [
        { name:  'LB_KLASNUMMER', fieldLabel: 'Klasnummer' },
        { name:  'KL_CODE', fieldLabel: 'Klascode' },
        { name:  'KL_OMSCHRIJVING', fieldLabel: 'Klas' },
        { name:  'AG_OMSCHRIJVING', fieldLabel: 'Studierichting' },
        { name:  'LB_LEERJAAR', fieldLabel: 'Leerjaar'},
        { name:  'LB_GRAAD', fieldLabel: 'Graad'}
      ]
    });
    this.gklasgenoten = new Ext.grid.GridPanel({
      store: this.dsklasgenoten,
      title: 'Klasgenoten',
      /*height: 200,*/
	  autoHeight: true,
      collapsible: true,
      collapsed: false,
      titleCollapse: true,
	  padding: '5 25 10 25',
	  cls: 'wisa-c-subtitle',	  
	  columns: [
        {dataIndex: 'LL_ID', header: 'ID', hidden: true, sortable: true},
        {dataIndex: 'LB_KLASNUMMER', header: 'Nr.', sortable: true, width: 40},
        {dataIndex: 'LL_VOORNAAM', header: 'Voornaam', sortable: true, width: 150},
        {dataIndex: 'LL_NAAM', header: 'Naam', sortable: true, width: 150}
      ]
    })
    return { iconCls: 'icon-wisa-panel-klas', cls: 'wisa-klasgroep', items : [this.fklas, this.gklasgenoten] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Huidige klas"
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params)
    }
    this.dsloopbaan.load({ params: {LL_ID: Params.ID}});
    this.dsklasgenoten.load({ params: {LL_ID: Params.ID}})
  }
}); 
