WISA.Forms.lbvakken = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsvakken: null,
  dsteam: null,
  gvakken: null,
  gteam: null,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsvakken = new WISA.ClientDataset({
      ProviderName: 'VakkenPakket',
      autoLoad: false
    });
    this.dsteam = new WISA.ClientDataset({
      ProviderName: 'PedagogischTeam',
      autoLoad: false
    });
    this.gvakken = new Ext.grid.GridPanel({
      title: 'Vakken',
      /*collapsible: false,
      height: 250,*/
	  autoHeight: true,
	  autoScroll: true,
      collapsible: true,
      collapsed: false	,
      titleCollapse: true,
	  padding: '5 25 10 25',
	  cls: 'wisa-c-subtitle',  
      store: this.dsvakken,
      columns: [
        {dataIndex: 'VAKCODE', header: 'Vakcode', width: 75, sortable: true},
        {dataIndex: 'VAKNAAM', header: 'Vaknaam', width: 200, sortable: true},
        {dataIndex: 'LEERKRACHTID', header: 'Leerkracht ID', width: 120, hidden: true},        
		{dataIndex: 'LEERKRACHTVOORNAAM', header: 'Voornaam leerkracht', width: 160, sortable: true},
        {dataIndex: 'LEERKRACHTNAAM', header: 'Naam leerkracht', width: 160, sortable: true}
      ]
    });
    this.gteam = new Ext.grid.GridPanel({
      title: 'Pedagogisch Team',
      /*collapsible: false,
      height: 250,*/
	  autoHeight: true,
      collapsible: true,
      collapsed: false	,
      titleCollapse: true,
	  padding: '5 25 10 25',
	  cls: 'wisa-c-subtitle',	  
      store: this.dsteam,
      columns: [
        {dataIndex: 'ROL', header: 'Rol', width: 250, sortable: true},
        {dataIndex: 'PERSONEELID', header: 'Leerkracht ID', width: 120, hidden: true},
        {dataIndex: 'PERSONEELVOORNAAM', header: 'Voornaam', width: 160, sortable: true},
        {dataIndex: 'PERSONEELNAAM', header: 'Naam', width: 160, sortable: true}
      ]
    });

    return { iconCls: 'icon-wisa-panel-vakkenleerkrachten', autoScroll: true, cls: 'wisa-vakkenleerkrachten', items: [this.gvakken,this.gteam] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Vakken en leerkrachten";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsvakken.load({params: {LL_ID: Params.ID}});
      this.dsteam.load({params: {LL_ID: Params.ID}});
    }
  }
}); 
