WISA.Forms.llbegeleiding = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsbegeleidingen: null,
  llid: -1,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsbegeleidingen = new WISA.ClientDataset({
      ProviderName : 'Begeleidingen',
      listeners: {load: this.begeleidingenLoaded.createDelegate(this) }
    });
    /* Create controls here */

    return { cls: 'wisa-leerlingbegeleiding', iconCls: 'icon-wisa-panel-leerlingbegeleiding' /*layout: 'accordion', html : 'Ophalen begeleidingen' */};
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Begeleidingen"
  },
  createBegeleidingPanel: function (b) {
    var i = [];
    if ( b.BG_OPMERKING != '') {
      i[0] = {  xtype: 'panel', autoHeight: true, padding: '0 25 0 0', html: '<div  class="wisa-txt-ag">' + b.BG_OPMERKING +'</div>'/*, cls : 'wisa-txt-ag'*/ };
    }
    i[i.length] = new Ext.grid.GridPanel({
      title: 'Acties in het kader van deze begeleiding',
      /*cls : 'wisa-interventies-overzicht',*/
      collapsible: true,
      border: false,
      collapsed: true,
	  titleCollapse: true,
	  cls: 'wisa-c-subtitle2',
	  padding: '0 25 25 25',
      autoHeight: true,
      store: new WISA.ClientDataset({
        ProviderName: 'BegeleidingInterventies',
        autoLoad: false
      }),
      columns: [
        { dataIndex: 'LI_DATUM', header: 'Datum', width: 75 , renderer: function(date, p, record) {
            return date.format('Y-m-d')
          }
        },
        /*{ dataIndex: 'LI_TIJD', header: 'tijd', width: 50, renderer:  function(time, p, record) {
            return time.format('G:i');
          }
        },
        { dataIndex: 'LI_TYPE', header: 'Type', width: 120 },*/
        { dataIndex: 'LI_OMSCHRIJVING', header: 'Omschrijving', width: 250},
        /*{ dataIndex: 'LI_MOTIEF', header: 'Motief', width: 120},*/
        { dataIndex: 'LI_OPMERKING', header: 'Opmerking', width: 300},
        { dataIndex: 'LI_BETROKKENPERSOON', header: 'Betrokken persoon', width: 200},
        /*{ dataIndex: 'LI_PLAATS', header: 'Plaats', width: 120 },*/
        { dataIndex: 'LI_DERDEN', header: 'Derden',  hidden: true} ,
        { dataIndex: 'LI_TYPECODE', header: 'Type code', hidden: true},
        { dataIndex: 'LI_MOTIEFCODE', header: 'Motief code', hidden: true},
        { dataIndex: 'LI_BETROKKENPERSOONTYPE', header: 'Type betrokken persoon', hidden: true}
      ],
      listeners: {
        expand: function (g) {
          if (g.getStore().getCount() == 0 ) {
             g.getStore().load({params: {BG_ID: b.BG_ID, LL_ID: this.llid}});
          }
        }.createDelegate(this)
      }
    });
    var p = new Ext.Panel({
      title: String.format('{0} {1} ({2})',b.BG_DATUM.format('Y-m-d'),b.BG_OMSCHRIJVING,b.BG_STATUS),
      /*cls : 'wisa-begeleidingen-fiche-eenvoudig',*/
      collapsible: true,
	  collapsed: true,
      titleCollapse: true,
	  cls: 'wisa-c-subtitle',
	  padding: '5 0 25 0', 
      layouts : b.BG_OPMERKING != '' ? 'border' : 'fit',
      items : i
    });
    return p;
  },
  begeleidingenLoaded: function (store,records, options) {
    this.removeAll();
    for (var i = 0; i < records.length; i++) {
      this.add(this.createBegeleidingPanel(records[i].data))
    }
    this.doLayout();
  },

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsbegeleidingen.load({params: {LL_ID: Params.ID}});
      this.llid = Params.ID;
    }
  }
}); 
