WISA.Forms.llinterventie = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsinterventies : null,
  ginterventies: null,
  pinterventie: null,
  tinterventie: null,
  /* Build the actual form contents*/
  interventiesLoaded: function (store,records, options) {
    if (records.length) {
       this.ginterventies.getSelectionModel().selectFirstRow();
//       tinterventie.overwrite(this.pinterventie.body, records[0].data)
    }
  },
  BuildForm: function () {
    this.dsinterventies = new WISA.GroupingClientDataset({
        ProviderName: 'Interventies',
        autoLoad: false,
        remoteGroup: false,
        groupField: 'LI_TYPE',
        listeners: {load: this.interventiesLoaded.createDelegate(this) }
    });
    this.pinterventie = new Ext.Panel({
      title: 'Detail interventie',
      /*cls: 'wisa-interventies-detail',*/
      height: 300,
      region: 'south',
      split: true,
      collapsible: false,
      border: true,
      cls: 'wisa-c-subtitle2',
      padding: '5 25 5 0',
	  autoScroll: true
    });
    this.tinterventie = new Ext.Template('<div class="wisa-txt-ag">'
	 +'<div class="wisa-det"><div class="wisa-det-label">Type:</div><div class="wisa-det-txt">{LI_TYPE}</div><div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Datum - uur:</div><div class="wisa-det-txt">{LI_DATUM:date("Y-m-d")}&nbsp;&nbsp;{LI_TIJD:date("H:i")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Omschrijving:</div><div class="wisa-det-txt">{LI_OMSCHRIJVING}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Motief:</div><div class="wisa-det-txt">{LI_MOTIEF:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Betrokken personen:</div><div class="wisa-det-txt">{LI_BETROKKENPERSOON:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Derden:</div><div class="wisa-det-txt">{LI_DERDEN:defaultValue("geen")}</div></div>'
     +'<div class="wisa-det"><div class="wisa-det-label">Opmerking:</div><div class="wisa-det-txt">{LI_OPMERKING}</div></div></div>'
    ,{
      compiled: true
    });
    this.ginterventies = new Ext.grid.GridPanel({
      title: 'Overzicht alle interventies',
      /*cls : 'wisa-interventies-overzicht',
      border: false,*/		  
	  collapsible: true,
	  collapsed: false,
	  titleCollapse: true,
	  cls: 'wisa-c-subtitle',
	  padding: '5 25 10 25',	  
      region: 'center',
      store: this.dsinterventies,
      cm: new Ext.grid.ColumnModel({
        defaults:{
          groupable: false,
          sortable: false
        },
        columns: [
          { dataIndex: 'LI_DATUM', header: 'Datum', width: 75, sortable: true, renderer: function(date, p, record) {
              return date.format('Y-m-d');
            }
          },
          /*{ dataIndex: 'LI_TIJD', header: 'tijd', width: 50, renderer:  function(time, p, record) {
              return time.format('G:i');
            }
          },*/
          { dataIndex: 'LI_TYPE', header: 'Type', width: 120, sortable: true, groupable: true },
          { dataIndex: 'LI_OMSCHRIJVING', header: 'Omschrijving', width: 200, sortable: true},
          /*{ dataIndex: 'LI_MOTIEF', header: 'Motief', sortable: true, width: 120 },
          { dataIndex: 'LI_MAAND', header: 'Maand', width: 120, sortable: true, groupable: true },*/
          { dataIndex: 'LI_OPMERKING', header: 'Opmerking', width: 300 },
          { dataIndex: 'LI_BETROKKENPERSOON', header: 'Betrokken persoon', sortable: true, width: 120 },
          /*{ dataIndex: 'LI_PLAATS', header: 'Plaats', sortable: true, width: 120 },*/
          { dataIndex: 'LI_DERDEN', header: 'Derden', width: 120,  hidden: true },
          { dataIndex: 'LI_TYPECODE', header: 'Type code', width: 120, sortable: true, hidden: true },
          { dataIndex: 'LI_MOTIEFCODE', header: 'Motief code', width: 120, sortable: true, hidden: true },
          { dataIndex: 'LI_BETROKKENPERSOONTYPE', header: 'Type betrokken persoon', width: 120, hidden: true }
        ]
      }),
      sm: new Ext.grid.RowSelectionModel({
        singleSelect: true,
        listeners: {
          rowselect : function(sm, index, record){
              this.tinterventie.overwrite(this.pinterventie.body, record.data);
            }.createDelegate(this)
        }
      }),
      view: new Ext.grid.GroupingView({
         hideGroupedColumn: false,
         enableNoGroups: true,
         showGroupName: true,
         groupTextTpl: '{text} ({[values.rs.length]} interventie{[values.rs.length > 1 ? "s" : ""]})'
      }),
      tbar: [{
        text:'Groepen openklappen',
        tooltip: {title:'Groepen openklappen',text:'Alle groepen openklappen'},
        iconCls: 'icon-wisa-btn-grexpand',
        scope:this,
        handler: function(btn, pressed){
            this.ginterventies.getView().expandAllGroups();
        }
      },{xtype: 'tbseparator'},
	    {
        text:'Groepen dichtklappen',
        tooltip: {title:'Groepen dichtklappen',text:'Alle groepen dichtklappen'},
        iconCls: 'icon-wisa-btn-grcollapse',
        scope:this,
        handler: function(btn, pressed){
            this.ginterventies.getView().collapseAllGroups();
        }
      }
	  ]
    });
    return { layout: 'border', iconCls: 'icon-wisa-panel-leerlinginterventie', cls: 'wisa-leerlinginterventie', items : [this.ginterventies, this.pinterventie ] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Interventies";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsinterventies.load({params: {LL_ID: Params.ID }})
    }
  }
}); 
