WISA.Forms.llloopbaanandere = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false,
  dsandere: null,
  gandere: null,
  gverleden: null,
  dsverleden: null,
  /* Control references go here*/

  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsverleden = new WISA.ClientDataset({
      ProviderName: 'LoopbaanVerleden',
      autoLoad: false
    });
    this.dsandere = new WISA.ClientDataset({
      ProviderName: 'LoopbaanAndereScholen',
      autoLoad: false
    });
    this.gverleden = new Ext.grid.GridPanel({
      store: this.dsverleden,
      /*region: 'center',*/
      title: 'Andere klassen in onze school',
      /*cls: 'wisa-verleden-huidigeschool',*/
	  autoHeight: true,
      collapsible: true,
      collapsed: false	,
      titleCollapse: true,
	  padding: '5 25 10 25',
	  cls: 'wisa-c-subtitle', 
      columns: [
        { dataIndex: 'LB_KLASNUMMER', header: 'Klasnr', width: 60 },
        { dataIndex: 'KL_CODE', header: 'Klascode', width: 70 },
        { dataIndex: 'KL_OMSCHRIJVING', header: 'Klas', width: 100 },
        { dataIndex: 'LB_VAN', header: 'Van', width: 100, renderer: function(date, p, record) {
                      return date.format('Y-m-d');
                    }
        },
        { dataIndex: 'LB_TOT', header: 'Tot', width: 100  , renderer: function(date, p, record) {
                      return date.format('Y-m-d');
                    }
        },
        { dataIndex: 'AG_OMSCHRIJVING', header: 'Richting', width: 140 },
        { dataIndex: 'LB_LEERJAAR', header: 'Leerjaar', width: 120 },
        { dataIndex: 'LB_GRAAD', header: 'graad', width: 120 }
      ]
    });
    this.gandere = new Ext.grid.GridPanel({
      store: this.dsandere,
      /*region: 'south',
      split: true,*/
	  autoHeight: true,
      collapsible: true,
      collapsed: false	,
      titleCollapse: true,
	  padding: '5 25 10 25',
	  cls: 'wisa-c-subtitle',	
      title: 'Gegevens over andere scholen',
      /*cls: 'wisa-verleden-andereschool',*/
      columns: [
        { dataIndex: 'LB_KLASNUMMER', header: 'Klasnr', width: 60 },
        { dataIndex: 'KL_CODE', header: 'Klascode', width: 70 },
        { dataIndex: 'KL_OMSCHRIJVING', header: 'Klas', width: 100 },
        { dataIndex: 'LB_VAN', header: 'Van', width: 100, renderer: function(date, p, record) {
                      return date.format('Y-m-d');
                    }
        },
        { dataIndex: 'LB_TOT', header: 'Tot', width: 100  , renderer: function(date, p, record) {
                      return date.format('Y-m-d');
                    }
        },
        { dataIndex: 'AG_OMSCHRIJVING', header: 'Richting', width: 140 },
        { dataIndex: 'LB_LEERJAAR', header: 'Leerjaar', width: 120 },
        { dataIndex: 'LB_GRAAD', header: 'graad', width: 120 },
        { dataIndex: 'IS_NAAMGEBRUIKER', header: 'School', width: 160, renderer: function(s, p, record) {
             if (s) {
               return s
             } else {
               return record.data.SC_NAAM + '('+record.data.GM_POSTCODE+' '+record.data.GM_DEELGEMEENTE+')'
             }
        }
        }
      ]
    });
    return {/* layout: 'border', */ IconCls: 'icon-wisa-panel-schoolverleden', cls: 'wisa-schoolverleden', items : [this.gverleden, this.gandere] };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Loopbaan";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsandere.load({params: {LL_ID: Params.ID }});
      this.dsverleden.load({params: {LL_ID: Params.ID }});
    }
  }
}); 
