WISA.Forms.llpersoonfiche = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  /* Control references go here*/
  border: false,
  ffiche: null,
  fouders: null,
  fgezin: null,
  padres: null,
  dspersonalia: null,
  dsadressen: null,
  dsbroerzus: null,
  pbroerzus: null,
  gbroerzus : null,


  /* Build the actual form contents*/
  BuildEdit: function (alabel,afield, avalue) {
     return {fieldLabel: alabel, name: afield, value: avalue }
  },
  DefaultFormConfig: function (atitle,acls) {
    return {
	  cls:'wisa-persoonsgegevens-'+acls,
      title: atitle,
      collapsible: true,
      titleCollapse: true,	  
      labelWidth: 160,
      labelPad: 10,
      labelSeparator: ':',
      labelAlign: 'right',
      padding: '5 0 10 0',
      defaultType: 'textfield',
      defaults: {
        readOnly: true,
        width: 300
      }
    }
  },
  PersonaliaLoaded: function (store,records, options) {
    if (records.length==1) {
      this.ffiche.getForm().loadRecord(records[0]);
      this.fouders.getForm().loadRecord(records[0])
    }
  },
  AdressenLoaded: function (store,records, options) {
    for (var i=0; i<records.length; i++) {
      var aform = null;
      var r = records[i];
      var cfg = this.DefaultFormConfig(r.data.LA_TYPEADRES,'adres');
      cfg=Ext.apply(cfg,{
        /*collapsed: i!=0,*/
	    cls: 'wisa-c-subtitle2',
        items: [
          this.BuildEdit('Naam','LA_NAAM'),
          this.BuildEdit('Aanspreking','LA_AANSPREKING'),
          this.BuildEdit('Straat','LA_STRAAT'),
          this.BuildEdit('Nr.','LA_STRAATNR'),
          this.BuildEdit('Bus','LA_STRAATBUS'),
          this.BuildEdit('Postcode','GM_POSTNUMMER'),
          this.BuildEdit('Gemeente','GM_DEELGEMEENTE'),
          this.BuildEdit('Telefoon','LA_TELEFOON')
        ]
      });
      aform = new Ext.form.FormPanel(cfg);
      aform.getForm().loadRecord(r);
      this.padres.add(aform)
    }
    this.padres.doLayout()
  },
  BroerzusLoaded: function (store,records, options) {
  },
  BuildForm: function () {
    this.dspersonalia = new WISA.ClientDataset({
      ProviderName: 'PersoonsGegevens',
      autoLoad: false,
      listeners: {load: this.PersonaliaLoaded.createDelegate(this)}
    });
    this.dsadressen = new WISA.ClientDataset({
      ProviderName: 'AdresGegevens',
      autoLoad: false,
      listeners: {load: this.AdressenLoaded.createDelegate(this)}
    });
    this.dsbroerzus = new WISA.ClientDataset({
      ProviderName: 'BroerzusGegevens',
      autoLoad: false,
      listeners: {load: this.BroerzusLoaded.createDelegate(this)}
    });
    var cfg = this.DefaultFormConfig('Personalia','personalia');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: false,
      items:[
        this.BuildEdit('Voornaam','LL_VOORNAAM'),
        this.BuildEdit('Naam','LL_NAAM'),
        this.BuildEdit('Andere voornamen','LL_VOORNAAM2'),
        this.BuildEdit('Roepnaam','LL_ROEPNAAM'),
        this.BuildEdit('Geslacht','LL_GESLACHT'),
        this.BuildEdit('Geboortedatum','LL_GEBOORTEDATUM'),
        this.BuildEdit('Geboortegemeente','LL_GEBOORTEGEMEENTE'),
        this.BuildEdit('Nationaliteit','LL_NATIONALITEIT'),
        this.BuildEdit('Moedertaal','LL_MOEDERTAAL'),
        this.BuildEdit('Nr. identiteitskaart','LL_IDENTITEITSKAARTNR'),
        this.BuildEdit('Rijksregisternummer','LL_RIJKSREGISTERNR'),
        this.BuildEdit('Onderwijsnummer','LL_BISNUMMER'),
        this.BuildEdit('Bankrekening','LL_BANKREKENING'),
        this.BuildEdit('E-mail','LL_EMAIL'),
        this.BuildEdit('GSM','LL_GSM'),
        this.BuildEdit('Noodtelefoon','LL_NOODTELEFOON'),
        this.BuildEdit('Noodtelefoon bij','LL_NOODTELEFOONBIJ')
       ]
    });
    this.ffiche = new Ext.form.FormPanel (cfg);
    cfg = this.DefaultFormConfig('Ouders','ouders');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: true,
      items: [
        this.BuildEdit('Naam vader','LL_VADERNAAM'),
        this.BuildEdit('Voornaam vader','LL_VADERVOORNAAM'),
        this.BuildEdit('Email vader','LL_VADEREMAIL'),
        this.BuildEdit('Burgerlijke staat vader','LL_VADERBURGERLIJKESTAAT'),
        this.BuildEdit('GSM vader','LL_VADERGSM'),
        this.BuildEdit('Naam moeder','LL_MOEDERNAAM'),
        this.BuildEdit('Voornaam moeder','LL_MOEDERVOORNAAM'),
        this.BuildEdit('E-mail moeder','LL_MOEDEREMAIL'),
        this.BuildEdit('Burgerlijke staat moeder','LL_MOEDERBURGERLIJKESTAAT'),
        this.BuildEdit('GSM vader','LL_MOEDERGSM')
      ]
    });
    this.fouders = new Ext.form.FormPanel (cfg);
    cfg = this.DefaultFormConfig('Adres','adressen');
    cfg=Ext.apply(cfg,{
      titleCollapse: true,
      collapsed: true
    });
    this.padres = new Ext.Panel ({
      title: 'Adressen',
      collapsible: true,
      collapsed: true,
      titleCollapse: true,
      autoHeight: true
      /*cls: 'wisa-persoonsgegevens-adres',
      layout: 'accordion',
	  height:300
	  layout: 'form'  mag niet omwille van autoheight en hor scrolling*/
    });
     var cellActions = new Ext.ux.grid.CellActions({
       align: 'left',
       callbacks: {
           'llpersoonfiche': function(grid,record,action,value) {
             Application.Ouders.ExpandLeerling(record.data.LL_ID);
             Application.ShowForm({form: 'llpersoonfiche', Params: {ID: record.data.LL_ID}});
           }
       }
     });
    this.gbroerzus = new Ext.grid.GridPanel({
      height: 200,
      title: 'Broer/zus',
      collapsible: true,
      collapsed: true,
      titleCollapse: true,
      enableHdMenu: false,
      padding: '0 25 0 25',
      store: this.dsbroerzus,
      columns: [
        {header: 'ID', dataIndex: 'LL_ID', hidden: true },
        {header: 'Voornaam', dataIndex: 'LL_VOORNAAM', align: 'center', cellActions:[{
                                                 iconCls:'llpersoonfiche'
                                                ,qtip:'Details bekijken'
                                                ,hide:true
                                                ,hideMode:'display'
                                         }]},
        {header: 'Naam', dataIndex: 'LL_NAAM', align: 'center' }
      ],
      plugins: [cellActions ]
    });
    return {
      autoScroll: true,
      iconCls: 'icon-wisa-panel-persoonsgegevens',
      cls: 'wisa-c-subtitle',
	  /*height: 124,*/
      items: [this.ffiche,this.fouders,this.padres, this.gbroerzus]
    };
  },

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Fiche";

  }, 
  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.llpersoonfiche.superclass.ApplyParams.call(this, Params);
      this.dspersonalia.load({params: {ID: Params.ID}});
      this.dsadressen.load({params: {ID: Params.ID}});
      this.dsbroerzus.load({params: {ID: Params.ID,ID2: Params.ID}});
    }
  }
});
