WISA.Forms.llrapport = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false, 
  /* Control references go here*/
  dsrapporten : null,
  grapporten : null,
  /* Build the actual form contents*/
  BuildForm: function () {
    this.dsrapporten = new WISA.ClientDataset({
      ProviderName: 'rapporten',
      autoLoad: false
    });
    this.grapporten = new Ext.grid.GridPanel({
      store: this.dsrapporten,
      title: 'Overzicht rapporten dit schooljaar',
	  collapsible: true,
      collapsed: false,
      titleCollapse: true,
	  autoHeight: true,
	  cls: 'wisa-c-subtitle',
	  padding: '5 25 10 25',  
      columns: [
        { dataIndex: 'PE_ID', header: 'ID', hidden: true},
        { dataIndex: 'PE_CODE', header: 'Periode', width: 100},
        { dataIndex: 'PED_DATUM', header: 'Datum', width: 100},
        { dataIndex: 'PE_OMSCHRIJVING', header: 'Omschrijving', width: 300, renderer:  function(oms, p, record) {
                       if (record.data.D_ID) {
                         return '<a href="getkast.cgi?D_ID='+record.data.D_ID+'">'+oms+'</a>';
                       } else {
                         return oms;
                       }
                    }
        }
      ]
    });
    /* Create controls here */
    return { layout: 'fit', items: [this.grapporten], iconCls: 'icon-wisa-panel-rapporten', cls: 'wisa-rapporten' };
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Rapporten"
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsrapporten.load({params:{LL_ID : Params.ID}})
    }
  }
}); 
