WISA.Forms.llzorgfiche = Ext.extend(WISA.Form, {
  /* Change some config properties here */
  border: false,
  dsmedisch: null,
  dszorgfiche: null,
  ficheloaded: false,
  zorgloaded: false,
  gzorg : null,
  fccount : 0,
  AddZorg : function(datum,type,opmerking) {
    if (opmerking.trim() != '') {
      this.fccount--;
      var d = {
        LZ_TYPECODE : 'MF',
        LZ_TYPE : type,
        LZ_GEBIED : 1,
        LZ_OPMERKING : opmerking,
        LZ_DATUM : datum,
        LZ_ID : this.fccount
      };
      var p = new this.dszorgfiche.recordType(d,this.fccount);
      this.dszorgfiche.add(p);
    }
  },
  ConvertFiche: function () {
    if (this.dsmedisch.getCount() != 0) {
      var d = this.dsmedisch.getAt(0).data;
      this.AddZorg(d.MF_ZICHTSINDS,'Zicht',d.MF_ZICHT);
      this.AddZorg(d.MF_SPRAAKSINDS,'Spraak',d.MF_SPRAAK);
      this.AddZorg(d.MF_GEHOORSINDS,'Gehoor',d.MF_GEHOOR);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK1);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK2);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK3);
      this.AddZorg(null,'Motoriek',d.MF_MOTORIEK4);
      this.AddZorg(null,'Andere',d.MF_ANDERE);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD1);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD2);
      this.AddZorg(null,'Andere',d.MF_VRIJVELD3);
      this.AddZorg(null,'Andere',d.MF_VRIJPARAM1);
      this.AddZorg(null,'Andere',d.MF_VRIJPARAM2);
      this.AddZorg(null,'SIS Kaart',d.MF_SISKAART);
      this.AddZorg(null,'Ziekenfondsnummer',d.MF_ZIEKENFONDSNUMMER);
    }
  },
  /* Control references go here*/
  MedischLoaded : function (store,records, options) {
    this.ficheloaded=true;
    if (this.zorgloaded) {
      this.ConvertFiche();
    }
  },
  ZorgLoaded : function (store,records, options) {
    this.zorgloaded=true;
    if (this.ficheloaded) {
      this.ConvertFiche();
    }
  },
  FormatDate : function(date, p, record) {
      if (!date) {
          return '';
      }
      var now = new Date();
      var d = now.clearTime(true);
      var notime = date.clearTime(true).getTime();
      var s = '';
      if (notime == d.getTime()) {
         s = 'Vandaag';
      } else {
         s = date.dateFormat('Y-m-d');
      }
      return s;
  },
  /* Build the actual form contents*/
  BuildForm: function () {
  /* Create controls here */
    this.dsmedisch = new WISA.ClientDataset({
      ProviderName: 'MedischeGegevens',
      autoLoad: false,
      listeners: {load: this.MedischLoaded.createDelegate(this)}
    });
    this.dszorgfiche = new WISA.ClientDataset({
      ProviderName: 'ZorgGegevens',
      autoLoad: false,
      listeners: {load: this.ZorgLoaded.createDelegate(this)}
    });
    this.gzorg = new Ext.grid.GridPanel({
      store: this.dszorgfiche,
	  autoHeight: true,
      collapsible: true,
      collapsed: false	,
      titleCollapse: true,
	  padding: '0 25 0 25',
      region: 'center',
      title: 'Zorgfiche & medische gegevens',
      columns : [
        {dataIndex: 'LZ_GEBIED', header: 'Gebied', width: 100, sortable: true, hidden: true },
        {dataIndex: 'LZ_TYPECODE', header: 'Code', width: 100, sortable: true },
        {dataIndex: 'LZ_TYPE', header: 'Type', width: 200, sortable: true },
        {dataIndex: 'LZ_OPMERKING', header: 'Omschrijving', width: 300 },
        {dataIndex: 'LZ_DATUM', header: 'Datum', width: 164, sortable: true, renderer: this.FormatDate },
        {dataIndex: 'LZ_ID', header: 'ID', width: 30, hidden: true}
      ]
    });
    return { 
	/*layout: 'border', 
	cls: 'wisa-zorgfiche', */
  	cls: 'wisa-c-subtitle',
	iconCls: 'icon-wisa-panel-zorgfiche', 
	items : [this.gzorg] /* return form config here*/ 
	};
  }, 

 /* Return an appropriate title for the form here */
  getFormTitle: function () {
    return "Zorgfiche ";
  }, 

  /* Process parameters which have been passed here */
  ApplyParams : function (Params) {
    if ( Params != undefined ) {
      /* Call inherited ApplyParams */
      WISA.Forms.login.superclass.ApplyParams.call(this, Params);
      this.dsmedisch.load({params: {ID: Params.ID}});
      this.dszorgfiche.load({params: {ID: Params.ID}});
    }
  }
});
