Ext.ns('WISA');

Application = new nsWISA.ux.SingletonApplication({
    submenu : {
      visible : true,
      config : {
        title: 'Mijn kinderen',
        layout: 'accordion',
        width: 200,
		maxSize: 300,
		minSize: 100,
        collapsed: false,
        border: false,
		split: true,
        cls:'wisa-panel-menu',
		margins: '5 0 2 5',
		cmargins: '5 5 2 5'
      }
    },
    mainmenu : {
      config : {
        xtype: 'toolbar',
        region: 'north',
        cls: 'wisa-top-toolbar',
        height: 30,
		margins: '0 0 0 0',
        items: [
        {
          xtype: 'panel',
          border: false,
          width: 203,
          height: 40,
          cls: 'wisa-panel-logo',
		  padding: '0 0 0 3',
		  autoLoad: { url: function () { return Application.getUrlApplication()+'/HTML/Logo'; html: '<div>VTI-Waregem</div>'}  }
        },
        '->',
        {
          /*xtype: 'button',*/
		  xtype: 'tbtext',
          text: 'Gebruikersgegevens',
          cls: 'wisa-profile',
          /*iconCls: 'profile',
          tooltip: 'Mijn gebruikersgegevens beheren',
          handler: function () {
            Application.ShowForm({form:'myprofile'});
          },*/
		  listeners: {
          render: function(txtItem) {
            txtItem.el.on({
                click: function() {
                    Application.ShowForm({form:'myprofile'});
                }
            });
          },
          single: true
		  }	
			  /*
              listeners: { beforerender: function (b) {
              b.setText(Application.getUserName());
            }		
          }*/
        },

		
		{
          /*xtype: 'button',*/
		  xtype: 'tbtext',
          text: 'Afmelden',
          cls: 'wisa-logout',
          /*iconCls: 'logout',
          tooltip: 'Afmelden en terug naar het aanmeldscherm',
          handler: function () { Application.DoLogout; },		  
          scope: function () { return Application; }*/
		  listeners: {
          render: function(txtItem) {
            txtItem.el.on({
                click: function() {
                    return Application;
                }
            });
          },
          single: true
		  }		  
		  
		  
		  
        }]
      }
    },
    bottompanel : {
      config : {
	    border: false,
        cls: 'wisa-panel-bottom',
        height: 32,
        layout: 'hbox',
        layoutConfig: {pack : 'center' },
        items : [{
            xtype: 'button',
            text: 'Gebruiksvoorwaarden',
            cls: 'wisa-bottom-button',
            handler: function (){
               Application.ShowDialog({form: 'showtext', Params: {fn: 'gebruiksvoorwaarden.txt', title: 'Gebruiksvoorwaarden'}});
            }
           }, {
            xtype: 'button',
            text: 'Privacy',
            cls: 'wisa-bottom-button',
            handler: function () {
              Application.ShowDialog({form: 'showtext', Params: {fn: 'privacy.txt', title: 'Privacy'}});
            }
           }]
      }
    }
  });

WISA.WebOuders = Ext.extend(Ext.util.Observable,{
   AddItems : function (r,Items) {
    for (var m = 0; m<Items.length; m+=1 ) {
      var mi = Items[m];
      var o = new Ext.tree.TreeNode({
         text: mi.Caption,
         iconCls: mi.Icon,
         leaf: Ext.isEmpty(mi.Items),
         qtip: mi.Hint,
		 expanded: true,
         listeners: {
           'click':
             { fn: function (mo) {
                     var it = mo;
                     return function(e) {
                       Application.ShowForm({form: it.Form, Params: it.Params});
                     }
                   }(mi),
               scope : this
             }
         }
      });
      r.appendChild(o);
      if (!Ext.isEmpty(mi.Items)) {
        this.AddItems(o,mi.Items);
      }
    };
  },
  CreateLeerlingMenu : function (menu) {
    var r = new Ext.tree.TreeNode({
        text: menu.Caption,
        expanded: true ,
         listeners: {
           'click':
             { fn: function(e) {
                       Application.ShowForm({form: menu.Items[0].Form, Params: menu.Items[0].Params});
                   },
               scope : this
             }
         }
    });
    this.AddItems(r,menu.Items);
    return r;
  },
  ExpandLeerling : function (llid)  {
    m = Ext.ComponentMgr.get('lltree'+llid);
    if (Ext.isDefined(m)) {
      m.expand();
    }
  },
  HandleLogin : function (){
    var mnu=Application.getMenu();
    var len=mnu.Items.length;
    var panels = [];
    var llid;
    for (var i=0; i<len; i++) {
      var m = mnu.Items[i];
      var pl = new Ext.tree.TreePanel({
        id:'lltree'+m.Params.ID,
        title: m.Caption,
        collapsible: true,
    	rootVisible:false,
        lines:false,
		padding: '3 5 5 5',
		collapsed: i!=0,
        root: this.CreateLeerlingMenu(m)
      });
      panels[panels.length]=pl;
      if (i==0)  {
       llid=m.Params.ID;
      }
    }
    Application.CreateMainForm();
    var mp = Application.getSubmenuPanel();
    mp.removeAll();
    mp.add(panels);
    mp.doLayout(false,true);
    Application.ShowForm({form:'llpersoonfiche', Params: {ID:llid}});
  }
});

Application.Ouders = new WISA.WebOuders();

