program lineinfo_test;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
{$ifdef mswindows}{$apptype console}{$endif}
uses
 sysutils;


procedure fpprof_info(position: string; frame_pointer: pointer);
var
  caller_addr: Pointer;
  func, source: shortstring;
  line: longint;
  sline: string;
  systemtime : string;
begin
  systemtime := FormatDateTime('yyyy-mm-dd HH:mm:ss:nn', Now);

  caller_addr := get_caller_addr(frame_pointer);
  GetLineInfo(ptruint(caller_addr), func, source, line);
  str(line, sline);

  writeln(Format('<%s> <%s> <%s> <%s> <%s>', [position, systemtime, func, source, sline]));
end;

procedure fpprof_entry_profile;
begin
  fpprof_info('entry ', get_frame);
end;

procedure fpprof_exit_profile;
begin
  fpprof_info('exit ', get_frame);
end; 

procedure HelloWorld;
begin
  fpprof_entry_profile;
  writeln('Graeme was here');
  fpprof_exit_profile;
end;
 
begin
  fpprof_entry_profile;
  HelloWorld;
  fpprof_exit_profile;
end.
