unit sqlwebouders; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 

Const
  SSelectSchoolData =
    'SELECT IS_ID, SC_ID FROM INSTELLING LEFT JOIN SCHOOL '+
    'ON (IS_SCHOOL_FK=SC_ID) WHERE (IS_CODE IN (%s))';
  SSelectRapportKastData =
    'SELECT K_ID,K_URI FROM KAST WHERE (K_CODE=''LLRAP'')';
  SSelectMainGroupData =
    'SELECT MG_ID '+
    'FROM MAINGROUP WHERE (MG_CODE IN (%s))';
  SSelectMijnLeerlingen =
    'SELECT LL_ID, LL_NAAM, LL_VOORNAAM, LL_MOEDEREMAIL, LL_VADEREMAIL, LL_VOOGDEMAIL, '+
    ' LL_VADERUSER_FK, LL_MOEDERUSER_FK, LL_VOOGDUSER_FK, LL_VADERNAAM, LL_VADERVOORNAAM,'+
    ' LL_MOEDERNAAM, LL_MOEDERVOORNAAM, LL_VOOGDNAAM, LL_VOOGDVOORNAAM, LL_RIJKSREGISTERNR'+
    ' FROM LEERLING WHERE '+
    '(LL_VADEREMAIL=:VaderEmail) OR (LL_MOEDEREMAIL=:MoederEmail) OR'+
    '(LL_VOOGDEMAIL=:VoogdEmail) ORDER BY LL_VOORNAAMSORT;';
  SSelectUser =
    'SELECT U_NAAM,U_PASWOORD FROM USERS WHERE (U_ID=:UID)';
  SSelectUserByName =
    'SELECT U_ID FROM USERS WHERE (U_NAAM=:U_NAAM)';
  SGetNewUserID =
    'SELECT GEN_ID(GEN_USER,1) AS THEID FROM  RDB$DATABASE;';
  SInsertUser
      = 'insert into USERS'+
        ' (U_NAAM, U_NAAMVOLLEDIG, U_ID, U_PASWOORD,'+
        '  U_VERANDERDDOOR, U_VERANDERDOP, U_KANVERANDERPASW) '+
        'values'+
        '  (:U_NAAM, :U_NAAMVOLLEDIG, :U_ID, :U_PASWOORD, '+
        '   0,''NOW'', ''+'' )';
  SUpdateUserPassword = 'UPDATE USERS SET U_PASWOORD=:U_PASWOORD WHERE (U_ID=:U_ID)';

  SUpdateLeerlingID = 'UPDATE LEERLING SET LL_USER_FK=:UID WHERE (LL_ID=:LL_ID)';
  SUpdateVaderID    = 'UPDATE LEERLING SET LL_VADERUSER_FK=:UID WHERE (LL_ID=:LL_ID)';
  SUpdateMoederID   = 'UPDATE LEERLING SET LL_MOEDERUSER_FK=:UID WHERE (LL_ID=:LL_ID)';
  SUpdateVoogdID    = 'UPDATE LEERLING SET LL_VOOGDUSER_FK=:UID WHERE (LL_ID=:LL_ID)';

  SSelectPersoonData = 'SELECT LL_RIJKSREGISTERNR, LL_VERANDERDOP, '+sLineBreak+
  ' LL_NAAM, LL_VOORNAAM, LL_VOORNAAM2, LL_ROEPNAAM, LL_GESLACHT, '+sLineBreak+
  ' LL_GEBOORTEDATUM, LL_GEBOORTEDATUMONGEKEND, '+sLineBreak+
  ' GM_DEELGEMEENTE AS LL_GEBOORTEGEMEENTE, GM_POSTNUMMER AS LL_GEBOORTEGEMEENTEPOSTNUMMER, '+sLineBreak+
  ' PMOET.P_OMSCHRIJVING AS LL_MOEDERTAAL, PTHUIS.P_OMSCHRIJVING AS LL_THUISTAAL, '+sLineBreak+
  ' PNOOD.P_OMSCHRIJVING AS LL_NOODTELEFOONBIJ, '+sLineBreak+
  ' LL_FOTO, NATIONALITEIT.NA_OMSCHRIJVING AS LL_NATIONALITEIT, '+sLineBreak+
  ' LL_GSM, LL_EMAIL, LL_OVERLIJDENSDATUM, LL_GOK, LL_FLAGS, LL_BISNUMMER, LL_IDENTITEITSKAARTNR, '+sLineBreak+
  ' LL_BANKREKENING, LL_BANKREKENINGBIC, LL_NOODTELEFOON, '+sLineBreak+
  ' LL_MOEDERNAAM, LL_MOEDERVOORNAAM, LL_VADERNAAM, LL_VADERVOORNAAM, '+sLineBreak+
  ' PMBURG.P_OMSCHRIJVING AS LL_MOEDERBURGERLIJKESTAAT, '+sLineBreak+
  ' PVBURG.P_OMSCHRIJVING AS LL_VADERBURGERLIJKESTAAT,'+sLineBreak+
  ' LL_MOEDEREMAIL, LL_MOEDERGSM, LL_VADEREMAIL, LL_VADERGSM '+sLineBreak+
  'FROM '+sLineBreak+
  ' LEERLING '+sLineBreak+
  ' LEFT JOIN GEMEENTE ON (LL_GEBOORTEGEMEENTE_FK=GM_ID) '+sLineBreak+
  ' LEFT JOIN PARMTAB PMOET ON (LL_MOEDERTAAL_FKP=PMOET.P_ID) '+sLineBreak+
  ' LEFT JOIN PARMTAB PTHUIS ON (LL_THUISTAAL_FKP=PTHUIS.P_ID) '+sLineBreak+
  ' LEFT JOIN PARMTAB PNOOD ON (LL_NOODTELEFOONBIJ_FKP=PNOOD.P_ID) '+sLineBreak+
  ' LEFT JOIN PARMTAB PMBURG ON (LL_MOEDERBURGERLIJKESTAAT_FKP=PMBURG.P_ID) '+sLineBreak+
  ' LEFT JOIN PARMTAB PVBURG ON (LL_VADERBURGERLIJKESTAAT_FKP=PVBURG.P_ID) '+sLineBreak+
  ' LEFT JOIN NATIONALITEIT ON (LL_NATIONALITEIT_FK=NA_ID) '+sLineBreak+
  'WHERE '+
  '  (LL_ID=:ID)';
Const
  SSelectAdresData = 'SELECT'+sLineBreak
        +'  LA_NAAM, LA_STRAAT, LA_STRAATNR, LA_STRAATBUS, LA_TELEFOON,'+sLineBreak
        +'  GM_POSTNUMMER, GM_DEELGEMEENTE, LN_ISOCODE,'+sLineBreak
        +'  PTYPE.P_CODE AS LA_TYPEADRESCODE,  PTYPE.P_OMSCHRIJVING AS LA_TYPEADRES,'+sLineBreak
        +'  PAANS.P_OMSCHRIJVING AS LA_AANSPREKING'+sLineBreak
        +'FROM'+sLineBreak
        +'  LEERLINGADRES'+sLineBreak
        +'  LEFT JOIN PARMTAB PTYPE ON (LA_TYPEADRES_FKP=PTYPE.P_ID)'+sLineBreak
        +'  LEFT JOIN PARMTAB PAANS ON (LA_AANSPREKING_FKP=PAANS.P_ID)'+sLineBreak
        +'  LEFT JOIN GEMEENTE ON (LA_GEMEENTE_FK=GM_ID)'+sLineBreak
        +'  LEFT JOIN LAND ON (LN_ID=GM_LAND_FK)'+sLineBreak
        +'WHERE'+sLineBreak
        +'  (LA_LEERLING_FK=:ID)';
  SSelectBroerZus = 'SELECT'+sLineBreak
                    +'  LL_ID,'+sLineBreak
                    +'  LL_NAAM,'+sLineBreak
                    +'  LL_VOORNAAM'+sLineBreak
                    +'FROM'+sLineBreak
                    +'  LEERLINGBROERZUS'+sLineBreak
                    +'  LEFT JOIN LEERLING ON (BZ_NAARLL_FK=LL_ID)'+sLineBreak
                    +'WHERE'+sLineBreak
                    +'  (BZ_VANLL_FK=:ID)'+sLineBreak
                    +'UNION'+sLineBreak
                    +'SELECT'+sLineBreak
                    +'  LL_ID,'+sLineBreak
                    +'  LL_NAAM,'+sLineBreak
                    +'  LL_VOORNAAM'+sLineBreak
                    +'FROM'+sLineBreak
                    +'  LEERLINGBROERZUS'+sLineBreak
                    +'  LEFT JOIN LEERLING ON (BZ_VANLL_FK=LL_ID)'+sLineBreak
                    +'WHERE'+sLineBreak
                    +'  (BZ_NAARLL_FK=:ID2)';

  SSelectLoopbaan = 'SELECT'+sLineBreak
                    +'  LB_ID,'+sLineBreak
                    +'  IU_ID,'+sLineBreak
                    +'  KL_ID,'+sLineBreak
                    +'  LB_KLASNUMMER,'+sLineBreak
                    +'  KL_CODE,'+sLineBreak
                    +'  KL_OMSCHRIJVING,'+sLineBreak
                    +'  LB_VAN,'+sLineBreak
                    +'  LB_TOT,'+sLineBreak
                    +'  IU_DATUMINSCHRIJVING,'+sLineBreak
                    +'  IU_DATUMUITSCHRIJVING,'+sLineBreak
                    +'  IS_ID,'+sLineBreak
                    +'  SC_ID,'+sLineBreak
                    +'  IS_NAAMGEBRUIKER,'+sLineBreak
                    +'  SC_NAAM,'+sLineBreak
                    +'  GM_DEELGEMEENTE,'+sLineBreak
                    +'  GM_POSTCODE,'+sLineBreak
                    +'  AG_OMSCHRIJVING,'+sLineBreak
                    +'  LB_VAKKENPAKKET_FK,'+sLineBreak
                    +'  PJAAR.P_OMSCHRIJVING AS LB_LEERJAAR,'+sLineBreak
                    +'  PGRAAD.P_OMSCHRIJVING AS LB_GRAAD'+sLineBreak
                    +'FROM'+sLineBreak
                    +'  INUIT'+sLineBreak
                    +'  LEFT JOIN LOOPBAAN ON (LB_INUIT_FK=IU_ID)'+sLineBreak
                    +'  LEFT JOIN KLASGROEP ON (LB_KLASGROEP_FK=KG_ID)'+sLineBreak
                    +'  LEFT JOIN KLAS ON (KG_KLAS_FK=KL_ID)'+sLineBreak
                    +'  LEFT JOIN ADMGROEP ON (LB_ADMGROEP_FK=AG_ID)'+sLineBreak
                    +'  LEFT JOIN SCHOOL ON (IU_SCHOOL_FK=SC_ID)'+sLineBreak
                    +'  LEFT JOIN INSTELLING ON (IS_SCHOOL_FK=SC_ID)'+sLineBreak
                    +'  LEFT JOIN GEMEENTE ON (GM_ID=SC_GEMEENTE_FK)'+sLineBreak
                    +'  LEFT JOIN PARMTAB PJAAR ON (LB_LEERJAAR_FKP=PJAAR.P_ID)'+sLineBreak
                    +'  LEFT JOIN PARMTAB PGRAAD ON (LB_GRAAD_FKP=PGRAAD.P_ID)'+sLineBreak
                    +'WHERE '+sLineBreak
                    +'  (IU_LEERLING_FK=:ID) '+sLineBreak
                    +'ORDER BY LB_VAN';

  SSelectKlasGenoten = 'SELECT'+sLineBreak
                       +'  LB_KLASNUMMER,'+sLineBreak
                       +'  LL_ID,'+sLineBreak
                       +'  LL_NAAM,'+sLineBreak
                       +'  LL_VOORNAAM'+sLineBreak
                       +'FROM'+sLineBreak
                       +'  KLASGROEP'+sLineBreak
                       +'  LEFT JOIN LOOPBAAN ON (LB_KLASGROEP_FK=KG_ID)'+sLineBreak
                       +'  LEFT JOIN INUIT ON (LB_INUIT_FK=IU_ID)'+sLineBreak
                       +'  LEFT JOIN LEERLING ON (LL_ID=IU_LEERLING_FK)'+sLineBreak
                       +'WHERE'+sLineBreak
                       +'  (KG_KLAS_FK=:KLID)'+sLineBreak
                       +'  AND (LL_ID<>:LLID)'+sLineBreak
                       +'  AND (LL_ID IS NOT NULL)'+sLineBreak
                       +'ORDER BY LB_KLASNUMMER';
  SSelectVakkenPakket = 'SELECT '+
          '  MN_CODE AS VAKCODE, MN_OMSCHRIJVING AS VAKNAAM, PS_ID AS LEERKRACHTID, PS_NAAM AS LEERKRACHTNAAM, PS_VOORNAAM AS LEERKRACHTVOORNAAM ' +
          'FROM '+
          '  KLAS '+
          '  LEFT JOIN PUNTENMODEL on (KL_Puntenmodel_FK = MU_ID) '+
          '  LEFT JOIN VAKKENMODELONDERDELEN on (MN_VAKKENMODEL_FK =MU_VakkenModel_FK) '+
          '  LEFT JOIN VAKTITULARIS on ((VT_Klas_FK = KL_ID) and (VT_Vakonderdeel_FK = MN_ID)) '+
          '  LEFT JOIN PERSONEEL on (PS_ID = VT_Personeel_FK) '+
          ' '+
          'WHERE '+
          '(KL_ID = :ID) ';


  SSelectPedagogischTeam = 'SELECT'+sLineBreak
                           +'  FA_EXTRADATA AS ROLMASK,'+sLineBreak
                           +'  FA_SOURCE2_FK AS LL_ID,'+sLineBreak
                           +'  FA_SOURCE_FK AS IU_ID,'+sLineBreak
                           +'  FA_SOURCE3_FK AS LB_ID,'+sLineBreak
                           +'  PS_ID AS PERSONEELID,'+sLineBreak
                           +'  PS_NAAM AS PERSONEELNAAM,'+sLineBreak
                           +'  PS_VOORNAAM AS PERSONEELVOORNAAM'+sLineBreak
                           +'FROM'+sLineBreak
                           +'  FAVOURITES'+sLineBreak
                           +'  LEFT JOIN PERSONEEL ON (FA_USER_FK=PS_USER_FK)'+sLineBreak
                           +'WHERE'+sLineBreak
                           +'  (FA_TYPE=1) AND (FA_SOURCE_FK IN (%s))';

  SSelectAfwezigheden = 'SELECT'+sLineBreak
                       +'  AF_ID,'+sLineBreak
                       +'  AF_VAN,'+sLineBreak
                       +'  AF_VANUUR,'+sLineBreak
                       +'  AF_TOT,'+sLineBreak
                       +'  AF_TOTUUR,'+sLineBreak
                       +'  AC_CODE,'+sLineBreak
                       +'  AC_OMSCHRIJVING,'+sLineBreak
                       +'  AC_KLEUR,'+sLineBreak
                       +'  AF_REFERENTIE,'+sLineBreak
                       +'  AF_COMMENTAAR,'+sLineBreak
                       +'  PBRIEF.IP_OMSCHRIJVING AS AF_BRIEFJEVAN'+sLineBreak
                       +'FROM'+sLineBreak
                       +'  AFWEZIG'+sLineBreak
                       +'  LEFT JOIN AFWEZIGCODES ON (AF_CODE_FKP=AC_ID)'+sLineBreak
                       +'  LEFT JOIN INSTELLINGPARMTAB PBRIEF ON (AF_BRIEFJEVAN_FKP=PBRIEF.IP_ID)'+sLineBreak
                       +'WHERE'+sLineBreak
                       +'  (AF_INUIT_FK IN (%s))';

  SSelectLeerlingZorg = 'SELECT'+sLineBreak
                        +'  LZ_ID,'+sLineBreak
                        +'  PTYPE.P_CODE AS LZ_TYPECODE,'+sLineBreak
                        +'  PTYPE.P_OMSCHRIJVING AS LZ_TYPE,'+sLineBreak
                        +'  LZ_GEBIED,'+sLineBreak
                        +'  LZ_OPMERKING,'+sLineBreak
                        +'  LZ_DATUM'+sLineBreak
                        +'FROM'+sLineBreak
                        +'  LEERLINGZORG'+sLineBreak
                        +'  LEFT JOIN PARMTAB PTYPE ON (LZ_TYPE_FKP=P_ID)'+sLineBreak
                        +'WHERE'+sLineBreak
                        +'  (LZ_LEERLING_FK=:ID)';

  SSelectMedischeFiche = 'SELECT'+sLineBreak
                         +'  MF_ID,'+sLineBreak
                         +'  MF_FLAGS,'+sLineBreak
                         +'  MF_SISKAART,'+sLineBreak
                         +'  MF_ZIEKENFONDSNUMMER,'+sLineBreak
                         +'  MF_ZICHT, MF_ZICHTSINDS,'+sLineBreak
                         +'  MF_GEHOOR, MF_GEHOORSINDS,'+sLineBreak
                         +'  MF_SPRAAK, MF_SPRAAKSINDS,'+sLineBreak
                         +'  MF_MOTORIEK1,'+sLineBreak
                         +'  MF_MOTORIEK2,'+sLineBreak
                         +'  MF_MOTORIEK3,'+sLineBreak
                         +'  MF_MOTORIEK4,'+sLineBreak
                         +'  MF_ANDERE,'+sLineBreak
                         +'  MF_VRIJVELD1,'+sLineBreak
                         +'  MF_VRIJVELD2,'+sLineBreak
                         +'  MF_VRIJVELD3,'+sLineBreak
                         +'  PVP1.P_OMSCHRIJVING AS MF_VRIJPARAM1,'+sLineBreak
                         +'  PVP2.P_OMSCHRIJVING AS MF_VRIJPARAM2'+sLineBreak
                         +'FROM'+sLineBreak
                         +'  LEERLINGMEDISCH'+sLineBreak
                         +'  LEFT JOIN PARMTAB PVP1 ON (MF_VRIJPARAM1_FKP=PVP1.P_ID)'+sLineBreak
                         +'  LEFT JOIN PARMTAB PVP2 ON (MF_VRIJPARAM2_FKP=PVP2.P_ID)'+sLineBreak
                         +'WHERE'+sLineBreak
                         +'  (MF_LEERLING_FK=:ID)';

  SSelectLVSRollen = 'SELECT'+sLineBreak
                     +'  LVR_ID,'+sLineBreak
                     +'  LVR_CODE,'+sLineBreak
                     +'  LVR_OMSCHRIJVING,'+sLineBreak
                     +'  LVR_USERNIVEAU'+sLineBreak
                     +'FROM'+sLineBreak
                     +'  LVSROLLEN'+sLineBreak
                     +'ORDER BY'+sLineBreak
                     +'  LVR_ID';

  SSelectLVSTypes = 'SELECT LVT_ID FROM LVSTYPES WHERE (LVT_TYPERECORD=:Type) AND (BIN_AND(LVT_ROLLEN,:Rol)<>0)';

  SSelectBegeleidingen = 'SELECT'+sLineBreak
                         +'  BG_ID,'+sLineBreak
                         +'  BG_DATUM,'+sLineBreak
                         +'  BG_TIJD,'+sLineBreak
                         +'  BG_ACHTERLIGGENDPROBLEEM,'+sLineBreak
                         +'  BG_BETROKKENPERSOON1,'+sLineBreak
                         +'  BG_BETROKKENPERSOON2,'+sLineBreak
                         +'  BG_BETROKKENPERSOON3,'+sLineBreak
                         +'  BG_BETROKKENPERSOONTYPE1,'+sLineBreak
                         +'  BG_BETROKKENPERSOONTYPE2,'+sLineBreak
                         +'  BG_BETROKKENPERSOONTYPE3,'+sLineBreak
                         +'  BG_EXTERNEIDENTIFICATIE1,'+sLineBreak
                         +'  BG_EXTERNEIDENTIFICATIE2,'+sLineBreak
                         +'  BG_FINANCIELETUSSENKOMST,'+sLineBreak
                         +'  BG_FLAGS,'+sLineBreak
                         +'  BG_INTERVENTIEMOTIEF,'+sLineBreak
                         +'  BG_OMSCHRIJVING,'+sLineBreak
                         +'  BG_OPMERKING,'+sLineBreak
                         +'  PSTATUS.P_OMSCHRIJVING AS BG_STATUS,'+sLineBreak
                         +'  LTYPE.LVT_CODE AS BG_TYPECODE,'+sLineBreak
                         +'  LTYPE.LVT_OMSCHRIJVING AS BG_TYPE,'+sLineBreak
                         +'  LSUBTYPE.LVT_CODE AS BG_SUBTYPECODE,'+sLineBreak
                         +'  LSUBTYPE.LVT_OMSCHRIJVING AS BG_SUBTYPE'+sLineBreak
                         +'FROM'+sLineBreak
                         +'  LEERLINGBEGELEIDING'+sLineBreak
                         +'  LEFT JOIN LVSTYPES LTYPE ON (BG_TYPE_FK=LTYPE.LVT_ID)'+sLineBreak
                         +'  LEFT JOIN LVSTYPES LSUBTYPE ON (BG_SUBTYPE_FK=LSUBTYPE.LVT_ID)'+sLineBreak
                         +'  LEFT JOIN PARMTAB PSTATUS ON (BG_STATUS_FKP=PSTATUS.P_ID)'+sLineBreak
                         +'WHERE'+sLineBreak
                         +'  (BG_LEERLING_FK=:ID)'+sLineBreak
                         +'  AND (BG_NIVEAU<=:Niveau)'+sLineBreak
                         +'  AND ((BG_SCHOOL_FK IN (%s)) OR (BG_SCHOOL_FK IS NULL))'+sLineBreak
                         +'  AND ((BG_SUBTYPE_FK IN (%s)) OR (BG_SUBTYPE_FK IS NULL))'+sLineBreak
                         +'  AND (BG_TYPE_FK IN (%s))'+sLineBreak
                         +'  AND (BIN_AND(BG_FLAGS,1)=0)'+sLineBreak
                         +'ORDER BY'+sLineBreak
                         +'  BG_DATUM DESC';

  SSelectInterventies = 'SELECT'+sLineBreak
                        +'  LI_ID,'+sLineBreak
                        +'  LI_DATUM,'+sLineBreak
                        +'  LI_TIJD,'+sLineBreak
                        +'  LI_BETROKKENPERSOON,'+sLineBreak
                        +'  LI_BETROKKENPERSOONTYPE,'+sLineBreak
                        +'  LI_DERDEN,'+sLineBreak
                        +'  LI_FLAGS,'+sLineBreak
                        +'  LI_NIVEAU,'+sLineBreak
                        +'  LI_OMSCHRIJVING,'+sLineBreak
                        +'  LI_OPMERKING,'+sLineBreak
                        +'  LI_PLAATS,'+sLineBreak
                        +'  LI_BEGELEIDING_FK,'+sLineBreak
                        +'  LTYPE.LVT_CODE LI_TYPECODE,'+sLineBreak
                        +'  LTYPE.LVT_OMSCHRIJVING LI_TYPE,'+sLineBreak
                        +'  PMOTIEF.P_CODE AS LI_MOTIEFCODE,'+sLineBreak
                        +'  PMOTIEF.P_OMSCHRIJVING AS LI_MOTIEF'+sLineBreak
                        +'FROM'+sLineBreak
                        +'  LEERLINGINTERVENTIE'+sLineBreak
                        +'  LEFT JOIN LVSTYPES LTYPE ON (LI_TYPE_FK=LVT_ID)'+sLineBreak
                        +'  LEFT JOIN PARMTAB PMOTIEF ON (LI_MOTIEF_FKP=PMOTIEF.P_ID)'+sLineBreak
                        +'WHERE'+sLineBreak
                        +'  (LI_LEERLING_FK = :ID)'+sLineBreak
                        +'  AND (LI_NIVEAU<=:Niveau)'+sLinebreak
                        +'  AND (LI_TYPE_FK IN (%s))'+sLineBreak
                        +'  AND ((LI_SCHOOL_FK IN (%s)) OR (LI_SCHOOL_FK IS NULL))'+sLineBreak
                        +'  AND (BIN_AND(LI_FLAGS,1)=0)'+sLineBreak
                        +'ORDER BY '+sLineBreak
                        +'  LI_DATUM DESC';

  SSelectKlasKalender = 'SELECT'+sLineBreak
                        +'  KD_ID,'+sLineBreak
                        +'  AC_ID,'+sLineBreak
                        +'  KD_VAN,'+sLineBreak
                        +'  KD_VANUUR,'+sLineBreak
                        +'  KD_TOT,'+sLineBreak
                        +'  KD_TOTUUR,'+sLineBreak
                        +'  AC_CODE,'+sLineBreak
                        +'  AC_OMSCHRIJVING'+sLineBreak
                        +'FROM'+sLineBreak
                        +'  KLAS'+sLineBreak
                        +'  LEFT JOIN AFWEZIGKALENDERDETAIL ON (KD_KALENDER_FK=KL_KALENDER_FK)'+sLineBreak
                        +'  LEFT JOIN AFWEZIGCODES ON (KD_CODE_FKP=AC_ID)'+sLineBreak
                        +'WHERE'+sLineBreak
                        +'  (KL_ID=:ID) AND ((KD_VANWEEKDAG=0) or (KD_TOTWEEKDAG=0)) '+sLineBreak
                        +'ORDER BY KD_VAN';

  SSelectFacturen = 'SELECT'+sLineBreak
                    +'  DB_CODE,  CD_DOCUMENT,'+sLineBreak
                    +'  CD_DATE, CD_SUMTOTAL, CD_ID, CD_DUEDATE,'+sLineBreak
                    +'  CD_MEMO, CD_DOMICIL, CD_NO, CD_OGM,'+sLineBreak
                    +'  P_CODE as TypeDetailboek, DB_SHAREPAYMENT,'+sLineBreak
                    +'  (Select Result from CalculatePaymentD(CommDocument.CD_ID)) as Betaald,'+sLineBreak
                    +'  (SELECT Result from CalculatePaymentT(CommDocument.CD_ID, CommDocument.CD_SUMTOTAL)) AS ISBETAALD'+sLineBreak
                    +' FROM'+sLineBreak
                    +'  COMMDOCUMENT'+sLineBreak
                    +'  LEFT JOIN DETAILBOOK ON (CD_Detailbook_FK = DB_ID)'+sLineBreak
                    +'  LEFT JOIN PARMTAB ON (DB_Type_FKP = P_ID)'+sLineBreak
                    +''+sLineBreak
                    +'WHERE'+sLineBreak
                    +'  (CD_Iden_FK = :ID)'+sLineBreak
                    +'  and (CD_TypeIden = ''L'')'+sLineBreak
                    +'  and (P_Code IN (''5'',''6''))'+sLineBreak
                    +'  and (DB_MainGroup_FK IN (%s))';

  SSelectArtikels = 'SELECT'+sLineBreak
                    +'  CDD_ID,'+sLineBreak
                    +'  CDD_DATEDELIVERY,'+sLineBreak
                    +'  CDD_PRICE,'+sLineBreak
                    +'  CDD_QTY,'+sLineBreak
                    +'  CDD_REDUCTION,'+sLineBreak
                    +'  CDT_DESCRIPTION,'+sLineBreak
                    +'  CDD_AMOUNT,'+sLineBreak
                    +'  AR_Code,'+sLineBreak
                    +'  AR_Description,'+sLineBreak
                    +'  PTYPE.P_CODE AS CDD_DETAILTYPECODE,'+sLineBreak
                    +'  PTYPE.P_OMSCHRIJVING AS CDD_DETAILTYPE'+sLineBreak
                    +'FROM'+sLineBreak
                    +'  COMMDETAIL'+sLineBreak
                    +'  left join CommDetailText on (CDT_CommDetail_FK = CDD_ID)'+sLineBreak
                    +'  left join Article on (AR_ID = CDD_Article_FK)'+sLineBreak
                    +'  left join parmtab ptype on (Ptype.P_ID=CDD_DETAILTYPE_FKP)'+sLineBreak
                    +'WHERE'+sLineBreak
                    +'  :ID in (CDD_CommDocument_FK,CDD_CommDocument2_FK )'+sLineBreak
                    +'order by'+sLineBreak
                    +'   CDD_SERIAL';

  SSelectRapportPeriodes = 'SELECT'+sLineBreak
                           +'  PE_ID,'+sLineBreak
                           +'  PE_CODE,'+sLineBreak
                           +'  PE_OMSCHRIJVING,'+sLineBreak
                           +'  PED_DATUM'+sLineBreak
                           +'FROM'+sLineBreak
                           +'  KLAS'+sLineBreak
                           +'  LEFT JOIN PUNTENMODEL ON (KL_PUNTENMODEL_FK=MU_ID)'+sLineBreak
                           +'  LEFT JOIN PERIODEMODEL ON (MU_PERIODEMODEL_FK=MP_ID)'+sLineBreak
                           +'  LEFT JOIN PERIODEMODELPERIODES ON (PE_PERIODEMODEL_FK=MP_ID)'+sLineBreak
                           +'  LEFT JOIN PERIODEMODELPERIODEDATA ON (PED_PERIODE_FK=PE_ID) AND (PED_SCHOOLJAAR_FK=KL_SCHOOLJAAR_FK)'+sLineBreak
                           +'WHERE'+sLineBreak
                           +'  (KL_ID=:ID)'+sLineBreak
                           +'  AND (PE_TYPEPERIODE=0)'+sLineBreak
                           +'ORDER BY'+sLineBreak
                           +'  PED_DATUM,PE_VOLGORDE';

  SSelectRapportDocumenten = 'SELECT'+sLineBreak
                             +'  D_ID,'+sLineBreak
                             +'  D_OMSCHRIJVING,'+sLineBreak
                             +'  D_NAAM,'+sLineBreak
                             +'  D_ORIGINELENAAM,'+sLineBreak
                             +'  D_REFERENTIE1,'+sLineBreak
                             +'  D_REFERENTIE2,'+sLineBreak
                             +'  D_LAATSTEWIJZIGING'+sLineBreak
                             +'FROM'+sLineBreak
                             +'  DOCUMENTEN'+sLineBreak
                             +'WHERE'+sLineBreak
                             +'  (D_KAST_FK=:K_ID) AND'+sLineBreak
                             +'  (D_BRON_FK=:IU_ID)'+sLineBreak
                             +'ORDER BY'+sLineBreak
                             +'  D_ID';

implementation

end.

