
Ext.define('WISA.configpanels.WebOuders',{
  extend: 'WISA.BaseConfigPanel',
  constructor : function(options) {
    options.buttons = options.buttons || [];
    options.items = options.items || [];
    options.defaults = options.defaults || {};

    options.height = 100;
    options.defaults.width = 300;
    options.labelWidth = 250;
    options.title = 'Website ouders';
    options.items.push(
     { xtype : 'textfield', name: 'InstellingsCodes', fieldLabel: 'Codes instellingen' },
     { xtype : 'textfield', name: 'HoofdGroepen', fieldLabel: 'Codes Hoofdgroepen' },
     { xtype : 'textfield', name: 'SchoolImage', fieldLabel: 'Logo school' },
     { xtype : 'textfield', name: 'SchoolWWW', fieldLabel: 'Website school' },
     { xtype : 'textfield', name: 'SchoolNaam', fieldLabel: 'Naam school' },
     { xtype : 'textfield', name: 'SchoolStraat', fieldLabel: 'School adres (straat+nr)'},
     { xtype : 'textfield', name: 'SchoolGemeente', fieldLabel: 'School adres (postcode+gemeente)'},
     { xtype : 'textfield', name: 'SchoolTelefoon', fieldLabel: 'School telefoon'},
     { xtype : 'textfield', name: 'SchoolFax', fieldLabel: 'School fax'},
     { xtype : 'textfield', name: 'SchoolEmail', fieldLabel: 'School email'},
     { xtype : 'textfield', name: 'LessenRoosterDir', fieldLabel: 'Map met lessenroosters' },
     { xtype : 'textfield', name: 'LessenRoosterExt', fieldLabel: 'Extensie lessenrooster bestand' },
     { xtype : 'textfield', name: 'OuderRol', fieldLabel: 'LVS Rol ouders' },
     { xtype : 'checkbox', name: 'ToonPersonalData', fieldLabel: 'Persoonsgegevens tonen' },
     { xtype : 'checkbox', name: 'ToonGezinData', fieldLabel: 'Gezinsgegevens tonen' },
     { xtype : 'checkbox', name: 'ToonRapporten', fieldLabel: 'Rapporten tonen' },
     { xtype : 'checkbox', name: 'ToonBegeleiding', fieldLabel: 'Begeleidingen tonen' },
     { xtype : 'checkbox', name: 'ToonInterventie', fieldLabel: 'Interventies tonen' },
     { xtype : 'checkbox', name: 'ToonMedischeFiche', fieldLabel: 'Medische fiche tonen' },
     { xtype : 'checkbox', name: 'ToonAfwezig', fieldLabel: 'Afwezigheden tonen' },
     { xtype : 'checkbox', name: 'ToonKalender', fieldLabel: 'Klas kalender tonen' },
     { xtype : 'checkbox', name: 'ToonExtraAdressen', fieldLabel: 'Extra adressen tonen' },
     { xtype : 'checkbox', name: 'ToonLoopbaan', fieldLabel: 'Loopbaangegevens tonen' },
     { xtype : 'checkbox', name: 'ToonLoopbaanAndereScholen', fieldLabel: 'Loopbaan andere scholen tonen' },
     { xtype : 'checkbox', name: 'ToonFacturen', fieldLabel: 'Facturen tonen' },
     { xtype : 'htmleditor', name: 'Motd', fieldLabel: 'Welkomstbericht', width: 600 }
    );
    /* Inherited */
    this.callParent(arguments);
  }
});


Application = new WISA.Application({
    submenu : {
      visible : true,
      config : {
        id   : 'submenu-kinderen',
        title: 'Mijn kinderen',
        layout: 'accordion',
        iconCls : 'menu-icon-kinderen',
        width: 300, // DEVart : changed width from 200 to 300
        collapsed: false,
        border: false,
        split: true,
        cls:'wisa-panel-menu',
        margins: '5 0 2 5',
        cmargins: '5 5 2 5'  
      }
    },
    mainmenu : {
      config : {
        xtype: 'toolbar',
        region: 'north',
        cls: 'wisa-top-toolbar',
        height: 185, // DEVart changed height from 30 to 185
        margins: '0 0 0 0',
        items: [
        {
          id : 'wisa-school-logo', // DEVart added id
          xtype: 'panel',
          border: false,
          width: 300, // DEVart changed width from 203 to 300
          height: 140, // DEVart changed height from 40 to 140
          cls: 'wisa-panel-logo',
          margins : '0 0 0 5', // DEVart added padding
          padding: '0 0 0 3',
          autoLoad: { url: function () { return Application.getUrlApplication()+'/HTML/Logo'; }  }
        },
        '->',
        /* DEVart : add item for selected child */
        {
          xtype: 'tbtext',
          text: '',
          cls: 'wisa-child',
          id: 'wisa-child-title'
        },
        {
          xtype: 'tbtext',
          text: 'Gebruikersgegevens',
          cls: 'wisa-profile',
          iconCls: 'profile',
          tooltip: 'Mijn gebruikersgegevens beheren',
          single: true,
          listeners: {
            render: function(txtItem) {
                txtItem.el.on('click', function() {
                    Ext.getCmp("wisa-child-title").addClass('wisa-child-hidden'); // DEVart added class
                    // DEVart collapse all items 
                     Ext.getCmp("submenu-kinderen").items.each(function(treenode){
                         if (!treenode.collapsed) {
                             treenode.collapse(false);
                         }
                     });
                     // DEVart : end
                     Application.ShowForm({form:'myprofile'}); 
                });
            },
            beforerender: function (b) {
              b.setText(Application.getUserName());
            }
          }
        },
        {
          xtype: 'tbtext',
          text: 'Afmelden',
          cls: 'wisa-logout',
          single: true,
          listeners: {
            render: function(txtItem) {
              txtItem.el.on('click', function() { return Application.DoLogout(); } );
            }
          }
         }
        ]
      }
    },
    // DEVart added bottomPanelConfig
    bottomPanelConfig : {
         id :'wisa-bottom', // DEVart : add id
         height : 50, // DEVart : add height
         region: 'south', 
         collapsible: false,
         items : [{
                id      : 'wisa-copyright',
                autoLoad: { url: function () { return Application.getUrlApplication()+'/HTML/Footer'; }  },
                //html    : '<ul><li class="first">Sintjozefsinstituut</li><li>Zilverstraat 26</li><li>8000 Brugge</li><li>TEL 050 33 19 43</li><li>FAX 050 34 30 51</li><li>info@sintjozefbrugge.be</li></ul>',
                height  : 50,
                border  : false,
                cls     : 'wisa-south',
                layout : 'auto',  
                width  : 800
         }]
    }
    // DEVart end
  });
Ext.define('WISA.models.ChildTree',{
    extend: 'Ext.data.Model',
    fields:[
        {name: 'id',type:'int'},
        {name: 'text', type:'string'},
        {name: 'Form', type:'string'},
        {name: 'qtip', type:'string'},
        {name: 'iconCls', type:'string'},
        {name: 'leaf', type:'bool'},
        {name: 'llid',type:'int'}
    ]
});
Ext.define('WISA.WebOuders',{
   extend: 'Ext.util.Observable',
   AddItems : function (r,Items) {
    for (var m = 0; m<Items.length; m+=1 ) {
      var mi = Items[m];
      var o = {
         text: mi.Caption,
         iconCls: mi.Icon,
         leaf: Ext.isEmpty(mi.Items),
         qtip: mi.Hint,
         expanded: true,
         Form: mi.Form,
         llid: Ext.isEmpty(mi.Params) ? -1 : mi.Params.ID
      };
      r.children.push(o);
      if (!Ext.isEmpty(mi.Items)) {
        o.children = [];
        this.AddItems(o,mi.Items);
      }
    }
  },
  CreateLeerlingMenu : function (menu) {
    var r = {
         text : menu.Caption,
         expanded : true,
         children : [],
    };
    this.AddItems(r,menu.Items);
    return Ext.create('Ext.data.TreeStore',{
       model: 'WISA.models.ChildTree',
       root: r
    });
  },
  ExpandLeerling : function (llid)  {
    m = Ext.ComponentMgr.get('lltree'+llid);
    if (Ext.isDefined(m)) {
      m.expand();
    }
  },
  HandleLogin : function (){
    var l = Ext.getCmp('wisa-login-logo');
    if (Ext.isObject(l)) l.destroy(); // DEVart hide logo
    if (!Application.getUserID()) {
      Application.CreateMainForm();
      Application.getSubmenuPanel().setTitle('Configuratie');
      Application.ShowForm({form: 'config'});
      Ext.getCmp("submenu-kinderen").addClass('configuratie-submenu'); // DEVart added class
      Ext.getCmp("wisa-child-title").addClass('wisa-child-hidden'); // DEVart added class
    } else {
      var mnu=Application.getMenu();
      var len=mnu.Items.length;
      var panels = [];
      var llid;
      var fChild = '';
      for (var i=0; i<len; i++) {
        var m = mnu.Items[i];
        // DEVart set default child
        if (i==0) {
            fChild = m.Caption;
        }
        // DEVart : end
        var pl = new Ext.tree.TreePanel({
          id:'lltree'+m.Params.ID,
          title: m.Caption,
          collapsible: true,
          collapsed : true,
          rootVisible:false,
          lines:false,
          padding: '3 5 7 5', // DEVart changed bottom padding from 5 to 7
          margins : {
              top:10,
              left : 10,
              right : 10,
              bottom : 10
          },
          // DEVart : add listener for changing child name
          listeners : {
             itemclick: { fn : function(view, record, item, index, e, eOpts ){
                         Application.ShowForm({form: record.get('Form'), Params: {ID : record.get('llid')}});
                 },
                 scope : this
              },
              render  : function(p) {
                  Ext.getCmp("wisa-child-title").addClass('wisa-child-hidden');
                  Ext.getCmp("wisa-child-title").setText('addClass'); 
              },
              expand  : function(p) {
                  Ext.getCmp("wisa-child-title").removeClass('wisa-child-hidden');
                  Ext.getCmp("wisa-child-title").setText(p.title);
                  var fNode = p.root.item(0);
                  fNode.select();
                  fNode.fireEvent('click', fNode);
                  //fNode.select();
                 //                  p.root.childNodes[0].select();
//                  p.root.childNodes[0].fireEvent('click');
              },
              collapse : function(p) {
                  Ext.getCmp("wisa-child-title").setText('');
                  Ext.getCmp("wisa-child-title").addClass('wisa-child-hidden');
                  Application.ShowForm({form:'motd', Params: {ID:llid}});
              }
          },
          // DEVart : end
          store: this.CreateLeerlingMenu(m)
        });
        panels[panels.length]=pl;
        if (i==0)  {
         llid=m.Params.ID;
        }
      }
      Application.CreateMainForm();
      var mp = Application.getSubmenuPanel();
      mp.removeAll();
      mp.add(panels);
      mp.doLayout(false,true);
      Application.ShowForm({form:'motd', Params: {ID:llid}});
    }
  }
});

Application.Ouders = new WISA.WebOuders();
Application.getConfigPanels().add('WebOuders',WISA.configpanels.WebOuders);

