unit ouderutils;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, websession, webwisa;

Type
  TCurrentID = (ciKL,ciLB,ciIU);

Procedure CheckLeerlingID(Session : TWisaWebSession; ID : Integer);
Function GetCurrentID(Session : TWisaWebSession; DB : TWISAWebdatabase; LLID : Integer;IDType : TCurrentID) : integer;

implementation

uses idlist,cfgwebouders;

Procedure CheckLeerlingID(Session : TWisaWebSession; ID : Integer);
Var
  L : TIDList;

begin
  L:=TIDList.Create;
  try
    L.AsString:=Session.Variables['Leerlingen'];
    If L.IndexOf(ID)=-1 then
      Raise Exception.CreateFmt('Leerling %d behoort niet tot "mijn kinderen"',[ID])
  finally
    L.Free;
  end;
end;

Function GetCurrentID(Session : TWisaWebSession; DB : TWISAWebdatabase; LLID : Integer;IDType : TCurrentID) : integer;
Const
    GetKlasSQL =
    'SELECT'+sLineBreak+
    '  KG_KLAS_FK AS KL_ID,'+sLineBreak+
    '  IU_ID,'+sLineBreak+
    '  LB_ID'+sLineBreak+
    'FROM'+sLineBreak+
    '  INUIT'+sLineBreak+
    '  LEFT JOIN LOOPBAAN ON (LB_INUIT_FK=IU_ID)'+sLineBreak+
    '  LEFT JOIN KLASGROEP ON (LB_KLASGROEP_FK=KG_ID)'+sLineBreak+
    'WHERE'+sLineBreak+
    '  (IU_LEERLING_FK = :LL_ID)'+sLineBreak+
    '  AND (:Datum between LB_VAN and LB_TOT)';

  Suff : Array [TCurrentID] of String = ('Klas','LB','IU');

Var
  V : String;
  QGetCurrentKlas: TWisaWebQuery;

begin
  Result:=-1;
  V:=Session.Variables['Current'+Suff[IDTYpe]+IntToStr(LLID)];
  If (V<>'') and (StrToIntDef(V,0)>0)then
    Exit(StrToIntDef(V,-1));
  QGetCurrentKlas:=TWisaWebQuery.Create(DB);
  try
    With QGetCurrentKlas do
      begin
      DataBase:=DB;
      Transaction:=DB.Transaction;
      SQL.Text:=GetKlasSQL;
      ParamByName('LL_ID').Asinteger:=LLID;
      ParamByName('Datum').AsDateTime:=Settings.Werkdatum;
      Open;
      try
        If (EOF and BOF) then
          Raise Exception.Create('Kan de huidige klas niet bepalen');
        Case IDTYpe of
          ciKL : Result:=FieldByName('KL_ID').AsInteger;
          ciLB : Result:=FieldByName('LB_ID').AsInteger;
          ciIU : Result:=FieldByName('IU_ID').AsInteger;
        end;
        Session.Variables['CurrentKlas'+IntToStr(LLID)]:=FieldByName('KL_ID').AsString;
        Session.Variables['CurrentLB'+IntToStr(LLID)]:=FieldByName('LB_ID').AsString;
        Session.Variables['CurrentIU'+IntToStr(LLID)]:=FieldByName('IU_ID').AsString;
      finally
        Close;
      end;
      end;
  finally
    QGetCurrentKlas.Free;
  end;
end;

end.

