unit wmfiles;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, HTTPDefs, websession, fpHTTP, fpWeb; 

type

  { TFilesWebModule }

  TFilesWebModule = class(TFPWebModule)
    procedure TFPWebActions0Request(Sender: TObject; ARequest: TRequest;
      AResponse: TResponse; var Handled: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FilesWebModule: TFilesWebModule;

implementation

uses cfgwebouders,webwisa;

{$R *.lfm}

{ TFilesWebModule }

procedure TFilesWebModule.TFPWebActions0Request(Sender: TObject;
  ARequest: TRequest; AResponse: TResponse; var Handled: Boolean);

Var
  KLID : Integer;
  S,E: String;

begin
  KLID:=StrToIntDef(ARequest.QueryFields.Values['KLID'],-1);
  If (KLID=-1) then
    Raise Exception.Create('Geen geldige klas ID doorgegeven');
  S:=Settings.LessenRoosterDir;
  If (S<>'') then
    begin
    E:=Settings.LessenRoosterExt;
    S:=IncludeTrailingPathDelimiter(S)+IntToStr(KlID)+E;
    If FileExists(S) then
      begin
      If Assigned(Logweb) then
        logweb('Downloading file : %s',[S]);
      Delete(E,1,1);
      AResponse.ContentType:='image/'+E;
      AResponse.ContentLength:=FileSize(S);
      AResponse.ContentStream:=TFileStream.Create(S,fmOpenRead);
      try
        AResponse.SendResponse;
      Finally
        AResponse.ContentStream.Free;
        AResponse.ContentStream:=Nil;
      end;
      Handled:=True;
      end
    else
      Raise Exception.CreateFmt('Lessenrooster voor klas %d bestaat niet',[KLID]);
    end
  else
    Raise Exception.Create('LessenroosterDirectory niet geconfigureerd');
end;

initialization
  RegisterHTTPModule('Files', TFilesWebModule);
end.

