unit wmhtml;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpHTTP, HTTPDefs, websession, webwisa;

type

  { THTMLModule }

  THTMLModule = class(TWisaRequestModule)
    procedure FooterRequest(Sender: TObject; ARequest: TRequest;
      AResponse: TResponse; var Handled: Boolean);
    procedure MOTDRequest(Sender: TObject; ARequest: TRequest;
      AResponse: TResponse; var Handled: Boolean);
    procedure TFPWebActions0Request(Sender: TObject; ARequest: TRequest;
      AResponse: TResponse; var Handled: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  HTMLModule: THTMLModule;

implementation

uses cfgwebouders;

{$R *.lfm}

ResourceString
 SErrNoSchool = '<em>Geen school geconfigureerd</em>';

{ THTMLModule }

Procedure AddLi(Var S: String; Txt : String);
begin
  if (Txt<>'') then
    S:=S+'<li>'+Txt+'</li>';
end;



procedure THTMLModule.FooterRequest(Sender: TObject; ARequest: TRequest;
  AResponse: TResponse; var Handled: Boolean);

Const
    SQL ='SELECT '+
          '  IS_NAAMGEBRUIKER, '+
          '  SC_INSTELLINGSNUMMER, SC_STRAAT, SC_STRAATNR, SC_STRAATBUS, '+
          '  GM_POSTNUMMER, GM_DEELGEMEENTE, SC_TELEFOON, SC_FAX, SC_EMAIL '+
          'FROM '+
          '  INSTELLING '+
          '  LEFT JOIN SCHOOL ON (IS_SCHOOL_FK=SC_ID) '+
          '  LEFT JOIN GEMEENTE ON (SC_GEMEENTE_FK=GM_ID) '+
          'WHERE '+
          '  (IS_ID=:IS_ID)';

Var
  q : TWisaWebQuery;
  N,A,G,T,F,E,S : String;

begin
   With Settings do
     if (SchoolStraat<>'') then
       begin
       N:=SchoolNaam;
       A:=SchoolStraat;
       G:=SchoolGemeente;
       T:=SchoolTelefoon;
       F:=SchoolFax;
       E:=SchoolEmail;
       end
     else if (ISIDS.Count=0) then
      S:=SErrNoSchool
     else
       begin
       Q:=DatabaseManager.GetQuery(Self,SQL);
       With Q do
         try
           ParamByName('IS_ID').AsInteger:=ISIDS[0];
           Open;
           try
             If (EOF and BOF) then
               S:=SErrNoSchool
             else
               begin
               N:=FieldByname('IS_NAAMGEBRUIKER').AsString;
               A:=FieldByName('SC_STRAAT').AsString;
               With FieldByname('SC_STRAATNR') do
                 if (AsString<>'') then
                   A:=A+' '+AsString;
               With FieldByname('SC_STRAATBUS') do
                 if (AsString<>'') then
                   A:=A+'/'+AsString;
               G:=FieldByName('GM_POSTNUMMER').AsString;
               G:=G+' '+FieldByName('GM_DEELGEMEENTE').AsString;
               T:=FieldByName('SC_TELEFOON').AsString;
               F:=FieldByName('SC_FAX').AsString;
               E:=FieldByName('SC_EMAIL').AsString;
               end;
           finally
             Close
           end;
         finally
           Free;
         end;
     end;
  If (s='') then
    begin
    S:='<ul><li class="first">'+N+'</li>';
    AddLi(S,A);
    AddLi(S,G);
    AddLi(S,'Tel '+T);
    AddLi(S,'Fax '+F);
    AddLi(S,E);
    S:=S+'</ul>';
    end;
  AResponse.Content:=S;
  AResponse.SendContent;
  Handled:=True;
end;

procedure THTMLModule.MOTDRequest(Sender: TObject; ARequest: TRequest;
  AResponse: TResponse; var Handled: Boolean);

Var
  S : String;

begin
  AResponse.ContentType:='text/html';
  S:=Settings.Motd.Text;
  If (S='') then
    S:='<H1>Meld aan als beheerder om het welkomstbericht in te stellen</H1>';
  AResponse.Content:=S;
  AResponse.SendResponse;
  Handled:=True;
end;

procedure THTMLModule.TFPWebActions0Request(Sender: TObject;
  ARequest: TRequest; AResponse: TResponse; var Handled: Boolean);
begin
  AResponse.ContentType:='text/html';
  AResponse.Content:=Format('<A HREF="%s"><IMG SRC="%s"/></A>',[Settings.SchoolWWW,Settings.SchoolImage]);
  AResponse.SendResponse;
  Handled:=True;
end;

initialization
  RegisterHTTPModule('HTML', THTMLModule);
end.

