unit wmoudersusers;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, websession, fpjson, fpextdirect,
  db, sqldb, webwisa, fpjsonrpc,  wmuser, webwisaauth,
  cfgwebouders;

type

  { TRPCOudersUsers }

  TRPCOudersUsers = class(TWisaWebRPCModule)
    Authenticate: TWisaRPCHandler;
    DBWisa: TWisaWebDatabase;
    QAuthenticateUser: TWisaWebQuery;
    QUpdateLastLogout: TWisaWebQuery;
    TRWIsa: TWisaWebTransaction;
    QUpdateLastLogin: TWisaWebQuery;
    Logout: TWisaRPCHandler;
    QScreenRights: TWisaWebQuery;
    QProfileRights: TWisaWebQuery;
    GetUserMenu: TWisaRPCHandler;
    ChangePassword: TWisaRPCHandler;
    QChangePassword: TWisaWebQuery;
    QCheckPasswordChange: TWisaWebQuery;
    QMijnLeerlingen: TWisaWebQuery;
    QFindUserByName: TWisaWebQuery;
    QInsertUser: TWisaWebQuery;
    QUpdateRolID: TWisaWebQuery;
    procedure AuthenticateExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
    procedure ChangePasswordExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
    procedure GetUserMenuExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
    procedure LogoutExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
  private
    procedure ReadSecurity;
    { private declarations }
  protected
    Class Function ActionName : String; override;
  public
    { public declarations }
  end;


var
  OudersRPCUsers: TRPCOudersUsers;


implementation

uses slcrypt,webwisamenu, idlist;

resourcestring
  SErrUnknownUser = 'Onbekende gebruiker: "%s"';
  SErrInvalidPassword = 'Ongeldig wachtwoord ingegeven.';
  SErrAccountExpired = 'Gebruiker "%s" niet langer geldig.';

Procedure RegisterOudersUserManagement;

begin
  RegisterWISARPCModule(TRPCOudersUsers);
end;

{ TRPCOudersUsers }

procedure TRPCOudersUsers.AuthenticateExecute(Sender: TObject;
  const Params: TJSONData; out Res: TJSONData);
begin

end;

procedure TRPCOudersUsers.ChangePasswordExecute(Sender: TObject;
  const Params: TJSONData; out Res: TJSONData);
begin

end;

procedure TRPCOudersUsers.GetUserMenuExecute(Sender: TObject;
  const Params: TJSONData; out Res: TJSONData);
begin

end;

procedure TRPCOudersUsers.LogoutExecute(Sender: TObject;
  const Params: TJSONData; out Res: TJSONData);
begin

end;

class function TRPCOudersUsers.ActionName: String;
begin
  Result:='WisaUserAPI';
end;
procedure TRPCOudersUsers.ReadSecurity;
begin

end;


initialization
  {$I wmoudersusers.lrs}

end.

